local G = DYCInfoPanel local cooking = require( "cooking" ) local Round = function(num) return math.floor(num + 0.5) end local Clamp = function(num, min, max) return math.min(math.max(num, min), max) end local function IsNumber(o) return o ~= nil and type(o) == "number" end local function IsPosNumber(o) return IsNumber(o) and o > 0 end local function IsNonNegNumber(o) return IsNumber(o) and o >= 0 end local function IsNegNumber(o) return IsNumber(o) and o < 0 end local function IsNonZeroNumber(o) return IsNumber(o) and o ~= 0 end local function IsString(o) return o ~= nil and type(o) == "string" end local function IsTable(o) return o ~= nil and type(o) == "table" end local function IsFunction(o) return o ~= nil and type(o) == "function" end local function IsNonEmptyString(o) return IsString(o) and #o > 0 end local function ConcatStrings(spl, ...) local tbl = {...} if IsTable(tbl[1]) then tbl = tbl[1] end local result = "" local count = 0 for k, v in pairs(tbl) do if IsNonEmptyString(v) or IsNumber(v) then count = count + 1 result = result..(count > 1 and spl or "" )..v end end return result end local TableCount = function(t) local c = 0 for k, v in pairs(t) do c = c + 1 end return c end local function IsDST() return TheSim:GetGameID() == "DST" end local function DYCGetPlayer() if IsDST() then return ThePlayer else return GetPlayer() end end local function HasString(key) return G.localization:HasString(key) end local function GetString(key, default) return G.localization:GetString(key, default) end local function GetFormattedTime(s, short, gameunit) if gameunit then local d = s / TUNING.TOTAL_DAY_TIME d = math.floor(d * 10 + 0.5) / 10 return d..GetString( "timer_day" ) end local m = math.max(math.floor(s / 60), 0) local h = math.max(math.floor(m / 60), 0) s = s - m * 60 m = m - h * 60 s = math.floor(s) if short then return(h > 0 and h..GetString( "timer_hour" ) or "" )..(m > 0 and m..GetString( "timer_minute" ) or "" )..(s > 0 and s..GetString( "timer_second" ) or "" ) else return(h > 0 and h..GetString( "timer_hour" ) or "" )..((m > 0 or h > 0) and m..GetString( "timer_minute" ) or "" )..s..GetString( "timer_second" ) end end local function GetNumberString(value) return ""..(value >= 20 and Round(value) or Round(value * 10) / 10) end local function GetPercentString(value) return(value >= 0.2 and Round(value * 100) or Round(value * 1000) / 10).."%" end local function GetSeasonString(s) local str = IsNonEmptyString(s) and STRINGS.UI and STRINGS.UI.SANDBOXMENU and STRINGS.UI.SANDBOXMENU[string.upper(s)] return str end local function GetNameString(prefab) local str = IsNonEmptyString(prefab) and STRINGS.NAMES[string.upper(prefab)] for i = 1, 9 do if str then break end str = str or (IsNonEmptyString(prefab) and STRINGS.NAMES[string.upper(prefab)..i]) end return str end local function GetActionString(act) return IsNonEmptyString(act) and STRINGS.ACTIONS[string.upper(act)] end local function GetComponent(inst, name) local cmp = inst and (inst.components and inst.components[name] or inst.dycComponents and inst.dycComponents[name]) return cmp end local function BattedGetBatNumber(self) local count = 0 for i, interiorname in ipairs(self.batcaves) do local interiorSpawner = GetWorld().components.interiorspawner local interior = interiorSpawner and interiorSpawner:GetInteriorByName(interiorname) if interior and interior.prefabs and #interior.prefabs > 0 then for i = #interior.prefabs, 1, - 1 do local potentialprefab = interior.prefabs[i] if potentialprefab.name == "vampirebat" then count = count + 1 end end end if interior and interior.object_list and #interior.object_list > 0 then for i = #interior.object_list, 1, - 1 do local prefab = interior.object_list[i] if prefab.prefab == "vampirebat" then count = count + 1 end end end end return count end local function GetHeater(inst) local components = inst and inst.components local heater = components and components.heater local burnable = components and components.burnable if not heater and burnable and inst.children then for k, v in pairs(inst.children) do if k and k.components.heater then heater = k.components.heater break end end end return heater end local function AddDescLine(t, s, c) table.insert(t, {text = s, component = c}) end local function DYCGetDescLines(inst, showPrefab) local lines = {} if not inst or not inst.IsValid then return lines end local instPrefab = inst.prefab local isSail = inst:HasTag( "sail" ) local comps = inst and inst.components local inventoryitem = comps.inventoryitem or GetComponent(inst, "inventoryitem" ) local owner = inventoryitem and inventoryitem.owner or nil local boathealth = comps.boathealth local health = comps.health or GetComponent(inst, "health" ) local sanity = comps.sanity or GetComponent(inst, "sanity" ) local hunger = comps.hunger or GetComponent(inst, "hunger" ) local combat = comps.combat or GetComponent(inst, "combat" ) local locomotor = comps.locomotor local drivable = comps.drivable local eater = comps.eater local follower = comps.follower or GetComponent(inst, "follower" ) local leader = comps.leader local domesticatable = comps.domesticatable local weapon = comps.weapon local obsidiantool = comps.obsidiantool local explosive = comps.explosive local armor = comps.armor local workable = comps.workable local pickable = comps.pickable local hackable = comps.hackable local shearable = comps.shearable local tool = comps.tool local finiteuses = comps.finiteuses local sewing = comps.sewing local fueled = comps.fueled local fuel = comps.fuel local perishable = comps.perishable local repairable = comps.repairable local repairer = comps.repairer local healer = comps.healer local dryer = comps.dryer local edible = comps.edible local dryable = comps.dryable local cookable = comps.cookable local growable = comps.growable local crop = comps.crop local harvestable = comps.harvestable local hatchable = comps.hatchable local teacher = comps.teacher local waterproofer = comps.waterproofer local insulator = comps.insulator local heater = GetHeater(inst) local temperature = comps.temperature local dapperness = comps.dapperness local equippable = comps.equippable or GetComponent(inst, "equippable" ) local burnable = comps.burnable local propagator = comps.propagator local appeasement = comps.appeasement local tradable = comps.tradable local inventory = comps.inventory local container = comps.container or GetComponent(inst, "container" ) local unwrappable = comps.unwrappable local childspawner = comps.childspawner local hounded = comps.hounded local batted = comps.batted local volcanomanager = comps.volcanomanager local basehassler = comps.basehassler local tigersharker = comps.tigersharker local krakener = comps.clock and DYCGetPlayer() and DYCGetPlayer().components.krakener local rocmanager = comps.rocmanager local nightmareclock = comps.nightmareclock if showPrefab and IsNonEmptyString(instPrefab) then local s = GetString( "prefab" )..":"..instPrefab AddDescLine(lines, s, "prefab" ) end if boathealth then local current, max = boathealth.currenthealth, boathealth.maxhealth local leaking = IsFunction(boathealth.IsLeaking) and boathealth:IsLeaking() if IsNumber(current) and IsPosNumber(max) then local s = GetString( "health" )..":"..Round(current).."/"..Round(max)..(leaking and " "..GetString( "leaking" ) or "" ) AddDescLine(lines, s, "boathealth" ) end end if health then local current, max = health.currenthealth, IsFunction(health.GetMax) and health:GetMax() or health.maxhealth if IsNumber(current) and IsPosNumber(max) then local s = GetString( "health" )..":"..Round(current).."/"..Round(max) AddDescLine(lines, s, "health" ) end end if sanity then local current, max = sanity.current, sanity.max if IsNumber(current) and IsPosNumber(max) then local s = GetString( "sanity" )..":"..Round(current).."/"..Round(max) AddDescLine(lines, s, "sanity" ) end end if hunger then local current, max = hunger.current, hunger.max if IsNumber(current) and IsPosNumber(max) then local s = GetString( "hunger" )..":"..Round(current).."/"..Round(max) AddDescLine(lines, s, "hunger" ) end end if combat then local damage, damage_1, damage_2 = 0, 0, 0 local wp = IsFunction(combat.GetWeapon) and combat:GetWeapon() if IsFunction(combat.CalcEstimatedDamage) then damage, damage_1, damage_2 = combat:CalcEstimatedDamage(wp) damage = IsNumber(damage) and damage or 0 damage_1 = IsNumber(damage_1) and damage_1 or 0 damage_2 = IsNumber(damage_2) and damage_2 or 0 end if damage <= 0 then local wpWp = wp and wp.components.weapon local defaultdamage = IsPosNumber(combat.defaultdamage) and combat.defaultdamage or 0 damage = wpWp and IsFunction(wpWp.GetDamage) and wpWp:GetDamage() or (wpWp and wpWp.damage) or 0 damage = IsPosNumber(damage) and damage or 0 damage = damage > 0 and damage or defaultdamage end local range = IsFunction(combat.GetAttackRange) and combat:GetAttackRange() range = IsPosNumber(range) and range or 0 local damageStr, rangeStr = nil, nil if damage > 0 then damageStr = damage_2 > 0 and GetNumberString(damage_1).."+"..GetNumberString(damage_2) or GetNumberString(damage) end if range > 0 then rangeStr = GetNumberString(range) end if damageStr then local s = "" s = s..(damageStr ~= nil and (GetString( "attackdamage" )..":"..damageStr) or "" )..(rangeStr ~= nil and ( " "..GetString( "range" )..":"..rangeStr) or "" ) AddDescLine(lines, s, "combat" ) end end if locomotor then local walkspeed, walkspeed_1, walkspeed_2 = nil, nil, nil if IsFunction(locomotor.GetWalkSpeed) then walkspeed, walkspeed_1, walkspeed_2 = locomotor:GetWalkSpeed() end walkspeed = IsPosNumber(walkspeed) and GetNumberString(walkspeed) walkspeed_1 = IsPosNumber(walkspeed_1) and GetNumberString(walkspeed_1) walkspeed_2 = IsPosNumber(walkspeed_2) and GetNumberString(walkspeed_2) local runspeed, runspeed_1, runspeed_2 = nil, nil, nil if IsFunction(locomotor.GetRunSpeed) then runspeed, runspeed_1, runspeed_2 = locomotor:GetRunSpeed() end runspeed = IsPosNumber(runspeed) and GetNumberString(runspeed) runspeed_1 = IsPosNumber(runspeed_1) and GetNumberString(runspeed_1) runspeed_2 = IsPosNumber(runspeed_2) and GetNumberString(runspeed_2) if walkspeed or runspeed then local str1 = walkspeed and GetString( "walkspeed" )..":"..(walkspeed_1 and walkspeed_2 and walkspeed_1.."+"..walkspeed_2 or walkspeed) or "" local str2 = runspeed and GetString( "runspeed" )..":"..(runspeed_1 and runspeed_2 and runspeed_1.."+"..runspeed_2 or runspeed) or "" local s = ConcatStrings( " " , str1, str2) AddDescLine(lines, s, "locomotor" ) end local speedsAdd = locomotor.speed_modifiers_add local speedsAddTimer = locomotor.speed_modifiers_add_timer local speedsMult = locomotor.speed_modifiers_mult local speedsMultTimer = locomotor.speed_modifiers_mult_timer local tbl, tbl2 = {}, {} if IsTable(speedsAdd) and IsTable(speedsAddTimer) then for k, v in pairs(speedsAdd) do local speed = IsNumber(v) and v or 0 local timer = IsPosNumber(speedsAddTimer[k]) and speedsAddTimer[k] or 0 if IsNonEmptyString(k) and speed ~= 0 then local lowerk = string.lower(k) k = HasString(lowerk) and GetString(lowerk) or k k = HasString( "speedboost_"..lowerk) and GetString( "speedboost_"..lowerk) or k local str = k..(speed > 0 and "+" or "" )..GetNumberString(speed)..(timer > 0 and "("..GetFormattedTime(timer)..")" or "" ) if timer > 0 then table.insert(tbl2, str) else table.insert(tbl, str) end end end end if IsTable(speedsMult) and IsTable(speedsMultTimer) then for k, v in pairs(speedsMult) do local speed = IsNumber(v) and v or 0 local timer = IsPosNumber(speedsMultTimer[k]) and speedsMultTimer[k] or 0 timer = IsNonEmptyString(k) and k == "WX_CHARGE" and IsNumber(inst.charge_time) and inst.charge_time or timer if IsNonEmptyString(k) and speed ~= 0 then local lowerk = string.lower(k) k = HasString(lowerk) and GetString(lowerk) or k k = HasString( "speedboost_"..lowerk) and GetString( "speedboost_"..lowerk) or k local str = k..(speed > 0 and "+" or "" )..GetPercentString(speed)..(timer > 0 and "("..GetFormattedTime(timer)..")" or "" ) if timer > 0 then table.insert(tbl2, str) else table.insert(tbl, str) end end end end if #tbl > 0 then local s = GetString( "speed" )..":"..ConcatStrings( " " , tbl) AddDescLine(lines, s, "locomotor" ) end if #tbl2 > 0 then local s = GetString( "speed" )..":"..ConcatStrings( " " , tbl2) AddDescLine(lines, s, "locomotor" ) end end if drivable then local runspeed = drivable.runspeed if IsNonZeroNumber(runspeed) then local s = GetString( "speed" )..":"..(runspeed > 0 and "+" or "" )..runspeed AddDescLine(lines, s, "drivable" ) end end if isSail then local speed = inst.sail_speed_mult speed = IsPosNumber(speed) and speed local acc = inst.sail_accel_mult acc = IsPosNumber(acc) and acc if speed or acc then local s = GetString( "sail" )..":"..(speed and GetString( "speed" )..Round(speed * 100).."%" or "" )..(speed and acc and " " or "" )..(acc and GetString( "acceleration" )..Round(acc * 100).."%" or "" ) AddDescLine(lines, s) end end if eater then local foodprefs = eater.foodprefs if IsTable(foodprefs) and #foodprefs > 0 then local s = GetString( "eater" ) local count = #foodprefs if count <= 6 then s = s.."(" for i = 1, count do local foodtype = foodprefs[i] if IsNonEmptyString(foodtype) then s = s..GetString( "foodtype_"..string.lower(foodtype), foodtype) if i < count then s = s.."," end end end s = s..")" else s = s.."("..count..GetString( "foodtypes" )..")" end AddDescLine(lines, s, "eater" ) end end if follower then local leader = IsTable(follower.leader) and follower.leader.components and follower.leader or nil local name = leader and IsFunction(leader.GetDisplayName) and leader:GetDisplayName() or nil name = IsNonEmptyString(name) and name or nil if leader and name then local p = IsFunction(follower.GetLoyaltyPercent) and follower:GetLoyaltyPercent() or nil local s = GetString( "leader" )..":"..name..(IsNonNegNumber(p) and " "..GetString( "loyalty" )..Round(p * 100).."%" or "" ) AddDescLine(lines, s, "follower" ) end end if leader then local followers = leader.followers if IsTable(followers) then local count = TableCount(followers) if count > 0 then local str1 = "" if count <= 3 then local i = 1 for k, v in pairs(followers) do local name = IsTable(k) and IsFunction(k.GetDisplayName) and k:GetDisplayName() or nil if IsNonEmptyString(name) then str1 = str1..name..(i < count and "," or "" ) end i = i + 1 end else str1 = count end local s = GetString( "followers" )..":"..str1 AddDescLine(lines, s, "leader" ) end end end if domesticatable then local domestication = domesticatable.domestication domestication = IsPosNumber(domestication) and domestication or nil local obedience = domesticatable.obedience obedience = IsPosNumber(obedience) and obedience or nil local tendencies = domesticatable.tendencies tendencies = IsTable(tendencies) and tendencies or nil local minobedience = domesticatable.minobedience minobedience = IsNonNegNumber(minobedience) and minobedience or nil local maxobedience = domesticatable.maxobedience maxobedience = IsNonNegNumber(maxobedience) and maxobedience or nil local str1 = domestication and GetString( "domestication" )..Round(domestication * 100).."%" or "" local str2 = obedience and GetString( "obedience" )..Round(obedience * 100).."%" or "" if str2 and minobedience and maxobedience and (minobedience ~= 0 or maxobedience ~= 1) then str2 = str2.."("..Round(minobedience * 100).."%-"..Round(maxobedience * 100).."%)" end local str3 = "" if tendencies then local default = tendencies.DEFAULT local ornery = tendencies.ORNERY local rider = tendencies.RIDER local pudgy = tendencies.PUDGY str3 = IsPosNumber(default) and ((IsNonEmptyString(str3) and str3 or "" )..GetString( "tendencies_default" )..string.format( "%0.3f" , default)) or str3 str3 = IsPosNumber(ornery) and ((IsNonEmptyString(str3) and str3.." " or "" )..GetString( "tendencies_ornery" )..string.format( "%0.3f" , ornery)) or str3 str3 = IsPosNumber(rider) and ((IsNonEmptyString(str3) and str3.." " or "" )..GetString( "tendencies_rider" )..string.format( "%0.3f" , rider)) or str3 str3 = IsPosNumber(pudgy) and ((IsNonEmptyString(str3) and str3.." " or "" )..GetString( "tendencies_pudgy" )..string.format( "%0.3f" , pudgy)) or str3 end if IsNonEmptyString(str1) or IsNonEmptyString(str2) then local s = str1..(IsNonEmptyString(str1) and " " or "" )..str2 AddDescLine(lines, s, "domesticatable" ) end if IsNonEmptyString(str3) then local s = str3 AddDescLine(lines, s, "domesticatable" ) end end if weapon then local damageStr, rangeStr = nil, nil local damage, damage_1, damage_2 = nil, nil, nil if IsFunction(weapon.GetDamage) then damage, damage_1, damage_2 = weapon:GetDamage() end damage = damage or weapon.damage local range = weapon.attackrange if IsPosNumber(damage) then if obsidiantool and IsFunction(obsidiantool.GetCharge) then local base_damage = weapon.damage local charge, maxcharge = obsidiantool:GetCharge() if IsPosNumber(base_damage) and IsNumber(charge) and IsPosNumber(maxcharge) then local obsdamage = base_damage * Clamp(charge / maxcharge, 0, 1) damage = damage + obsdamage damage_1 = IsPosNumber(damage_1) and damage_1 + obsdamage end end if IsPosNumber(damage_1) and IsPosNumber(damage_2) then damage_1 = GetNumberString(damage_1) damage_2 = GetNumberString(damage_2) damageStr = damage_1.."+"..damage_2 else damageStr = GetNumberString(damage) end end if IsPosNumber(range) then rangeStr = GetNumberString(range) end if damageStr or rangeStr then local s = GetString( "weapon" )..":" s = s..(damageStr ~= nil and (GetString( "damage" )..damageStr) or "" )..(damageStr ~= nil and " " or "" )..(rangeStr ~= nil and (GetString( "range" )..rangeStr) or "" ) AddDescLine(lines, s, "weapon" ) end end if explosive then local range = explosive.explosiverange range = IsNumber(range) and range or 0 local damage = explosive.explosivedamage damage = IsNumber(damage) and damage or 0 local damage2 = explosive.buildingdamage damage2 = IsNumber(damage2) and damage2 or 0 if damage > 0 or range > 0 then local s = GetString( "explosive" )..":" s = s..ConcatStrings( " " , damage > 0 and GetString( "damage" )..GetNumberString(damage), damage2 > 0 and GetString( "buildingdamage" )..GetNumberString(damage2), range > 0 and GetString( "range" )..GetNumberString(range)) AddDescLine(lines, s, "explosive" ) end end if armor then local current, max = armor.condition, armor.maxcondition local abs = armor.absorb_percent if IsNumber(current) and IsPosNumber(max) then local s = GetString( "armor" )..(IsPosNumber(abs) and ( "("..GetString( "absorbpercent" )..Round(abs * 100).."%)" ) or "" )..":" s = s..GetNumberString(current).."/"..GetNumberString(max) AddDescLine(lines, s, "armor" ) end end if workable then local workleft, maxwork = workable.workleft, workable.maxwork local action = workable.action if IsPosNumber(workleft) then local actName = IsTable(action) and IsNonEmptyString(action.str) and action.str or nil local actStr = GetActionString(actName) actStr = IsNonEmptyString(actStr) and actStr or (IsTable(actStr) and IsNonEmptyString(actStr.GENERIC) and actStr.GENERIC) or GetString( "other" ) local s = GetString( "workable" )..(actName and "("..actStr..")" or "" )..":"..Round(workleft)..(IsPosNumber(maxwork) and "/"..Round(maxwork) or "" ) AddDescLine(lines, s, "workable" ) end end if pickable then local product = pickable.product product = GetNameString(product) local canpick = IsFunction(pickable.CanBePicked) and pickable:CanBePicked() local numtoharvest = pickable.numtoharvest local targettime = pickable.targettime local timeleft = IsPosNumber(targettime) and targettime - GetTime() local regentime = pickable.regentime local s = "" if IsNonEmptyString(product) then s = GetString( "pickproduct" )..":"..product..(IsPosNumber(numtoharvest) and numtoharvest > 1 and "x"..numtoharvest or "" ) elseif canpick then s = GetString( "pickable" ) end if IsPosNumber(timeleft) then s = s..(IsNonEmptyString(s) and " " or "" )..GetString( "regen" )..":"..Round(timeleft).."("..GetFormattedTime(timeleft, nil, true)..")"..(IsPosNumber(regentime) and "/"..Round(regentime) or "" ) end if IsNonEmptyString(s) then AddDescLine(lines, s, "pickable" ) end end if hackable then local product = hackable.product local hacksleft = hackable.hacksleft local targettime = hackable.targettime local timeleft = IsPosNumber(targettime) and targettime - GetTime() local hackStr = GetActionString( "hack" ) product = GetNameString(product) local s = "" if IsNonEmptyString(product) then s = GetString( "hackproduct" )..":"..product end if IsPosNumber(hacksleft) and IsNonEmptyString(hackStr) then s = s..(IsNonEmptyString(s) and " " or "" )..hackStr..hacksleft end if IsPosNumber(timeleft) then s = s..(IsNonEmptyString(s) and " " or "" )..GetString( "regen" )..":"..Round(timeleft).."("..GetFormattedTime(timeleft, nil, true)..")" end if IsNonEmptyString(s) then AddDescLine(lines, s, "hackable" ) end end if shearable then local product = shearable.product local product_amt = shearable.product_amt product = GetNameString(product) if IsNonEmptyString(product) then local s = GetString( "shearproduct" )..":"..product..(IsPosNumber(product_amt) and product_amt > 1 and "x"..product_amt or "" ) AddDescLine(lines, s, "shearable" ) end end if tool then local count = 0 local eff = {} local actions = tool.actions or tool.action if IsTable(actions) then for k, v in pairs(actions) do if IsTable(k) and IsNonEmptyString(k.str) and IsPosNumber(v) then eff[k.str] = v count = count + 1 end end end local s = GetString( "tool" )..":" if count <= 4 and count > 0 then local count2 = 0 for k, v in pairs(eff) do if count2 > 0 then s = s.." " end local actStr = GetActionString(k) actStr = IsNonEmptyString(actStr) and actStr or (IsTable(actStr) and IsNonEmptyString(actStr.GENERIC) and actStr.GENERIC) or GetString( "other" ) s = s..actStr..Round(v) count2 = count2 + 1 end elseif count > 0 then s = s..count..GetString( "tool_actions" ) end AddDescLine(lines, s, "tool" ) end if dryer then local product = dryer.product product = GetNameString(product) local timeleft = IsFunction(dryer.GetTimeToDry) and dryer:GetTimeToDry() if IsNonEmptyString(product) then local s = GetString( "dryproduct" )..":"..product..(IsPosNumber(timeleft) and "("..GetFormattedTime(timeleft)..")" or "" ) AddDescLine(lines, s, "dryer" ) end end if edible then local foodtype = edible.foodtype local ownerOwner = IsTable(owner) and IsTable(owner.components) and IsTable(owner.components.inventoryitem) and owner.components.inventoryitem.owner or nil local healthValue = edible.GetHealth and edible:GetHealth(ownerOwner or owner) or edible.healthvalue local hungerValue = edible.GetHunger and edible:GetHunger(ownerOwner or owner) or edible.hungervalue local sanityValue = edible.GetSanity and edible:GetSanity(ownerOwner or owner) or edible.sanityvalue local caffeinedelta = edible.caffeinedelta local caffeineduration = edible.caffeineduration local ftStr, healthStr, hungerStr, sanityStr, coffeeStr = nil, nil, nil, nil, nil if IsNonEmptyString(foodtype) then ftStr = "("..GetString( "foodtype_"..string.lower(foodtype), foodtype)..")" end if IsNonZeroNumber(healthValue) then healthStr = GetString( "health" )..GetNumberString(healthValue) end if IsNonZeroNumber(hungerValue) then hungerStr = GetString( "hunger" )..GetNumberString(hungerValue) end if IsNonZeroNumber(sanityValue) then sanityStr = GetString( "sanity" )..GetNumberString(sanityValue) end if IsPosNumber(caffeinedelta) and IsPosNumber(caffeineduration) then coffeeStr = GetString( "speed" )..GetNumberString(caffeinedelta).."("..GetFormattedTime(caffeineduration, true)..")" end if ftStr or healthStr or hungerStr or sanityStr then local s = ConcatStrings( " " , healthStr, hungerStr, sanityStr, coffeeStr) s = GetString( "edible" )..(ftStr or "" )..(#s > 0 and ":" or "" )..s AddDescLine(lines, s, "edible" ) end if IsNonEmptyString(instPrefab) then local ing = cooking.ingredients[instPrefab] if IsTable(ing) and IsTable(ing.tags) then local tbl = {} for foodtag, value in pairs(ing.tags) do if IsNonEmptyString(foodtag) and IsPosNumber(value) then table.insert(tbl, GetString( "foodtag_"..string.lower(foodtag), foodtag)..value) end end local s = GetString( "foodtags" )..":"..ConcatStrings( "," , tbl) AddDescLine(lines, s, "edible" ) end end end if dryable then local product = dryable.product product = GetNameString(product) local drytime = dryable.drytime if IsNonEmptyString(product) then local s = GetString( "dryproduct" )..":"..product..(IsPosNumber(drytime) and "("..GetFormattedTime(drytime, true)..")" or "" ) AddDescLine(lines, s, "dryable" ) end end if cookable then local product = cookable.product product = IsFunction(product) and product(inst) or product product = GetNameString(product) if IsNonEmptyString(product) then local s = GetString( "cookproduct" )..":"..product AddDescLine(lines, s, "cookable" ) end end if growable then local targettime = growable.targettime local stage = growable.stage local stages = growable.stages if IsPosNumber(targettime) then local growtime = targettime - GetTime() local stageStr = IsNonNegNumber(stage) and IsTable(stages) and "("..Round(stage).."/"..#stages..")" or "" local s = GetString( "growable" )..":"..GetFormattedTime(growtime)..stageStr AddDescLine(lines, s, "growable" ) end end if crop then local product = crop.product_prefab product = GetNameString(product) local percent = crop.growthpercent if IsNonEmptyString(product) then local s = GetString( "crop" )..":"..product..(IsPosNumber(percent) and percent <= 1 and " "..Round(percent * 100).."%" or "" ) AddDescLine(lines, s, "crop" ) end end if harvestable then local product = harvestable.product product = GetNameString(product) local produce = harvestable.produce local maxproduce = harvestable.maxproduce local growtime = harvestable.growtime if IsNonEmptyString(product) then local str1 = IsNumber(produce) and (Round(produce)..(IsNumber(maxproduce) and "/"..Round(maxproduce) or "" )) or "" local s = GetString( "harvest" )..":"..product..str1..(IsPosNumber(growtime) and "("..GetFormattedTime(growtime, true)..")" or "" ) AddDescLine(lines, s, "harvestable" ) end end if hatchable then local progress = hatchable.progress local cracktime = hatchable.cracktime local hatchtime = hatchable.hatchtime local state = hatchable.state local totaltime = IsString(state) and state == "unhatched" and cracktime or hatchtime if IsPosNumber(progress) then local s = GetString( "hatchable" )..":"..Round(progress)..(IsPosNumber(totaltime) and "/"..Round(totaltime) or "" ) AddDescLine(lines, s, "hatchable" ) end end if finiteuses then local current, max = finiteuses.current, finiteuses.total if IsNumber(current) and IsPosNumber(max) then local s = GetString( "uses" )..":"..(Round(current * 10) / 10).."/"..Round(max) AddDescLine(lines, s, "finiteuses" ) end end if sewing then local repair_value = sewing.repair_value if IsPosNumber(repair_value) then local s = GetString( "sewing" )..Round(repair_value) AddDescLine(lines, s, "sewing" ) end end if fueled then local current, max = fueled.currentfuel, fueled.maxfuel local fueltype = fueled.fueltype if IsNumber(current) and IsPosNumber(max) then current = GetNumberString(current) max = GetNumberString(max) local str1 = IsNonEmptyString(fueltype) and "("..GetString( "fuel_"..fueltype, fueltype)..")" or "" local s = GetString( "fuel" )..str1..":"..current.."("..GetFormattedTime(current, nil, true)..")/"..max AddDescLine(lines, s, "fueled" ) end end if fuel then local fuelvalue = fuel.fuelvalue local fueltype = fuel.fueltype if IsPosNumber(fuelvalue) then local str1 = IsNonEmptyString(fueltype) and "("..GetString( "fuel_"..fueltype, fueltype)..")" or "" local s = GetString( "fuel" )..str1..Round(fuelvalue) AddDescLine(lines, s, "fuel" ) end end if perishable then local current, max = perishable.perishremainingtime, perishable.perishtime local spoiled = IsFunction(perishable.IsSpoiled) and perishable:IsSpoiled() local stale = IsFunction(perishable.IsStale) and perishable:IsStale() if IsNumber(current) and IsPosNumber(max) then current = GetNumberString(current) max = GetNumberString(max) local str1 = spoiled and GetString( "spoiled" ) or (stale and GetString( "stale" )) or GetString( "fresh" ) local modifier = owner and ((owner:HasTag( "fridge" ) and (inst:HasTag( "frozen" ) and not owner:HasTag( "nocool" ) and not owner:HasTag( "lowcool" ) and TUNING.PERISH_COLD_FROZEN_MULT or TUNING.PERISH_FRIDGE_MULT)) or (owner:HasTag( "spoiler" ) and owner:HasTag( "poison" ) and TUNING.PERISH_POISON_MULT) or (owner:HasTag( "spoiler" ) and TUNING.PERISH_GROUND_MULT)) or 1 modifier = IsNonNegNumber(modifier) and modifier or 1 local s = str1..":"..current..(modifier > 0 and "("..GetFormattedTime(current / modifier, nil, true)..")" or "" ).."/"..max AddDescLine(lines, s, "perishable" ) end end if repairable then local needsRepairs = IsFunction(repairable.NeedsRepairs) and repairable:NeedsRepairs() local repairmaterial = repairable.repairmaterial if needsRepairs then local str1 = IsNonEmptyString(repairmaterial) and "("..GetString( "repairmaterial_"..string.lower(repairmaterial), repairmaterial)..")" or "" local s = GetString( "repairable" )..str1 AddDescLine(lines, s, "repairable" ) end end if repairer then local workrepairvalue = repairer.workrepairvalue local healthrepairvalue = repairer.healthrepairvalue local perishrepairvalue = repairer.perishrepairvalue local userepairvalue = repairer.userepairvalue workrepairvalue = IsPosNumber(workrepairvalue) and GetString( "work" )..GetNumberString(workrepairvalue) healthrepairvalue = IsPosNumber(healthrepairvalue) and GetString( "health" )..GetNumberString(healthrepairvalue) perishrepairvalue = IsPosNumber(perishrepairvalue) and GetString( "freshness" )..GetNumberString(perishrepairvalue) userepairvalue = IsPosNumber(userepairvalue) and GetString( "uses" )..GetNumberString(userepairvalue) local repairmaterial = repairer.repairmaterial if workrepairvalue or healthrepairvalue or perishrepairvalue or userepairvalue then local str1 = IsNonEmptyString(repairmaterial) and "("..GetString( "repairmaterial_"..string.lower(repairmaterial), repairmaterial)..")" or "" local s = GetString( "repairer" )..str1..":"..ConcatStrings( " " , workrepairvalue, healthrepairvalue, perishrepairvalue, userepairvalue) AddDescLine(lines, s, "repairer" ) end end if healer then local hp = healer.health if IsPosNumber(hp) then local s = GetString( "heal" )..":"..GetNumberString(hp)..GetString( "health" ) AddDescLine(lines, s, "healer" ) end end if teacher then local recipe = teacher.recipe local name = GetNameString(recipe) if IsNonEmptyString(name) then local s = GetString( "unlock" )..":"..name AddDescLine(lines, s, "teacher" ) end end if waterproofer then local effectiveness = IsFunction(waterproofer.GetEffectiveness) and waterproofer:GetEffectiveness() if IsPosNumber(effectiveness) then local s = GetString( "waterproofer" )..":"..Round(effectiveness * 100).."%" AddDescLine(lines, s, "waterproofer" ) end end if insulator then local insulatorType = GetSeasonString(insulator.type) local insulation = insulator.insulation if IsNumber(insulation) then local s = GetString( "insulator" )..(IsNonEmptyString(insulatorType) and "("..insulatorType..")" or "" )..":"..(Round(insulation * 10) / 10) AddDescLine(lines, s, "insulator" ) end end if heater then local heat = IsFunction(heater.GetHeat) and heater:GetHeat(DYCGetPlayer()) if IsNonZeroNumber(heat) then local s = GetString( "heat" )..":"..(Round(heat * 10) / 10) AddDescLine(lines, s, "heater" ) end end if temperature then local current, max, min = temperature.current, temperature.maxtemp, temperature.mintemp if IsNumber(current) then local s = GetString( "temperature" )..":"..(Round(current * 10) / 10)..(IsNumber(max) and IsNumber(min) and "("..Round(min).."~"..Round(max)..")" or "" ) AddDescLine(lines, s, "temperature" ) end end if dapperness then local value = IsFunction(dapperness.GetDapperness) and dapperness:GetDapperness(dapperness.owner or DYCGetPlayer()) if IsNumber(value) and value ~= 0 then local s = GetString( "dapperness" )..":"..(Round(value * 1000) / 1000) AddDescLine(lines, s, "dapperness" ) end end if equippable then local equipslot = equippable.equipslot or equippable.boatequipslot local walkspeedmult = IsFunction(equippable.GetWalkSpeedMult) and equippable:GetWalkSpeedMult() or equippable.walkspeedmult local dapperness = IsFunction(equippable.GetDapperness) and equippable:GetDapperness(equippable.owner or DYCGetPlayer()) local strs = {} if IsNonEmptyString(equipslot) then table.insert(strs, GetString( "equipslot" )..":"..GetString( "equipslot_"..equipslot, equipslot)) end if IsPosNumber(walkspeedmult) and walkspeedmult ~= 1 then table.insert(strs, GetString( "speed" )..Round(walkspeedmult * 100).."%" ) end if IsNumber(dapperness) and dapperness ~= 0 then table.insert(strs, GetString( "dapperness" )..(Round(dapperness * 1000) / 1000)) end if #strs > 0 then local s = "" for i = 1, #strs do s = s..(i > 1 and " " or "" )..strs[i] end AddDescLine(lines, s, "equippable" ) end end if burnable then local s = GetString( "burnable" )..(propagator and " "..GetString( "propagator" ) or "" ) AddDescLine(lines, s, "burnable" ) end if appeasement then local appeasementvalue = appeasement.appeasementvalue if IsNumber(appeasementvalue) and appeasementvalue ~= 0 then local s = GetString( "appeasement" )..":"..appeasementvalue AddDescLine(lines, s, "appeasement" ) end end if tradable then local goldvalue = tradable.goldvalue local s = GetString( "tradable" )..(IsPosNumber(goldvalue) and ":"..GetString( "goldvalue" )..goldvalue or "" ) AddDescLine(lines, s, "tradable" ) end if inventory then local num, max = IsFunction(inventory.NumItems) and inventory:NumItems(), inventory.maxslots local equipslots = inventory.equipslots local num2 = IsTable(equipslots) and TableCount(equipslots) or 0 local str1, str2, str3 = "" , "" , "" if IsNonNegNumber(num) and IsPosNumber(max) then str1 = Round(num).."/"..Round(max) if num + num2 <= 5 and IsTable(inventory.itemslots) then local tbl = {} for k, v in pairs(inventory.itemslots) do if IsTable(v) and IsNonEmptyString(v.prefab) then table.insert(tbl, GetNameString(v.prefab) or "" ) end end str3 = ConcatStrings( "," , tbl) str3 = IsNonEmptyString(str3) and "("..str3..")" or "" end end if IsTable(equipslots) then if num2 <= 5 then local tbl = {} for k, v in pairs(equipslots) do if IsTable(v) and IsNonEmptyString(v.prefab) then table.insert(tbl, GetNameString(v.prefab) or "" ) end end str2 = ConcatStrings( "," , tbl) str2 = IsNonEmptyString(str2) and "["..str2.."]" or "" else str2 = "["..num2.."]" end end if IsNonEmptyString(str1) or IsNonEmptyString(str2) then local s = GetString( "inventory" )..":"..str1..str3..str2 AddDescLine(lines, s, "inventory" ) end end if container then local num, max = IsFunction(container.NumItems) and container:NumItems(), container.numslots local equipslots = container.boatequipslots local num2 = IsTable(equipslots) and TableCount(equipslots) or 0 local str1, str2 = "" , "" if IsNonNegNumber(num) and IsPosNumber(max) then str1 = Round(num).."/"..Round(max) if IsTable(container.slots) then local tbl = {} local tooMany = num + num2 > 5 for k, v in pairs(container.slots) do if IsTable(v) and IsNonEmptyString(v.prefab) then table.insert(tbl, GetNameString(v.prefab) or "" ) end if tooMany and #tbl > 0 then break end end local str = ConcatStrings( "," , tbl) str = IsNonEmptyString(str) and "("..str..(tooMany and "..." or "" )..")" or "" str1 = str1..str end end if IsTable(equipslots) then if num2 <= 5 then local tbl = {} for k, v in pairs(equipslots) do if IsTable(v) and IsNonEmptyString(v.prefab) then table.insert(tbl, GetNameString(v.prefab) or "" ) end end str2 = ConcatStrings( "," , tbl) str2 = IsNonEmptyString(str2) and "["..str2.."]" or "" else str2 = "["..num2.."]" end end local s = str1..str2 if IsNonEmptyString(s) then s = GetString( "container" )..":"..s AddDescLine(lines, s, "container" ) end end if unwrappable then local itemdata = unwrappable.itemdata local num = IsTable(itemdata) and #itemdata if IsPosNumber(num) then local s = GetString( "contains" )..":" if num <= 5 then local count = 1 for i = 1, num do local pf = IsTable(itemdata[i]) and itemdata[i].prefab local name = GetNameString(pf) if IsNonEmptyString(name) then s = s..(count > 1 and "," or "" )..name count = count + 1 end end else s = s..Round(num)..GetString( "items" ) end AddDescLine(lines, s, "unwrappable" ) end end if childspawner then local childname = childspawner.childname childname = GetNameString(childname) local rarechild = childspawner.rarechild rarechild = GetNameString(rarechild) local childreninside = childspawner.childreninside local numchildrenoutside = childspawner.numchildrenoutside local maxchildren = childspawner.maxchildren if IsNonEmptyString(childname) then local s = GetString( "spawner" ).."("..childname..(IsNonEmptyString(rarechild) and ","..rarechild or "" )..")" local str1 = IsNonNegNumber(childreninside) and IsNonNegNumber(numchildrenoutside) and IsPosNumber(maxchildren) and ":["..childreninside.."+"..numchildrenoutside.."]/"..maxchildren s = s..(IsNonEmptyString(str1) and str1 or "" ) AddDescLine(lines, s, "childspawner" ) end end if inventoryitem then local enchanter = IsFunction(inventoryitem.GetEnchanter) and inventoryitem:GetEnchanter() local str = IsTable(enchanter) and IsFunction(enchanter.GetDisplayString) and enchanter:GetDisplayString() if IsNonEmptyString(str) then local s = GetString( "enchantments" )..":"..str AddDescLine(lines, s, "inventoryitem" ) end end if hounded then local houndstorelease = hounded.houndstorelease houndstorelease = IsNumber(houndstorelease) and houndstorelease or 0 local timetoattack = hounded.timetoattack timetoattack = IsNumber(timetoattack) and timetoattack or 0 local timetonexthound = hounded.timetonexthound timetonexthound = IsNumber(timetonexthound) and timetonexthound or 0 local s = "" if timetoattack > 0 and houndstorelease > 0 then s = string.format(GetString( "houndtimer" ), Round(houndstorelease * 10) / 10, GetFormattedTime(timetoattack)) elseif timetonexthound > 0 and houndstorelease > 0 then s = string.format(GetString( "houndtimer2" ), Round(houndstorelease * 10) / 10, GetFormattedTime(timetonexthound)) end if IsNonEmptyString(s) then AddDescLine(lines, s, "hounded" ) end end if batted then local timetoattack = batted.timetoattack local batnum = BattedGetBatNumber(batted) batnum = IsNumber(batnum) and batnum or 0 timetoattack = IsNumber(timetoattack) and timetoattack or 0 if timetoattack > 0 then local s = string.format(GetString( "battimer" ), Round(batnum), GetFormattedTime(timetoattack)) AddDescLine(lines, s, "batted" ) end end if volcanomanager then local segs = IsFunction(volcanomanager.GetNumSegmentsUntilEruption) and volcanomanager:GetNumSegmentsUntilEruption() local segtime = IsNonNegNumber(TUNING.SEG_TIME) and TUNING.SEG_TIME local daytime = IsNonNegNumber(TUNING.TOTAL_DAY_TIME) and TUNING.TOTAL_DAY_TIME if IsNonNegNumber(segs) and segtime and daytime then local timeleftinseg = math.floor(daytime * GetClock():GetNormTime() / segtime) * segtime timeleftinseg = daytime * GetClock():GetNormTime() - timeleftinseg local timeleft = segs * segtime - timeleftinseg local s = string.format(GetString( "volcanotimer" ), GetFormattedTime(timeleft)) AddDescLine(lines, s, "volcanomanager" ) end end if basehassler then local hasslers = basehassler.hasslers if IsTable(hasslers) and next(hasslers) then for k, hassler in pairs(hasslers) do local nameStr = GetNameString(hassler.prefab) or "" local state = IsFunction(basehassler.GetHasslerState) and basehassler:GetHasslerState(k) local stateStr = IsNonEmptyString(state) and (state == "WAITING" or state == "WARNING" ) and "("..GetString( "timer_"..state)..")" or "" local timer = hassler.timer if IsNonEmptyString(nameStr) and IsNonEmptyString(stateStr) then local s = nameStr..stateStr..(IsNumber(timer) and ":"..GetFormattedTime(timer) or "" ) AddDescLine(lines, s, "basehassler" ) end end end end if tigersharker then local timeleft1 = IsFunction(tigersharker.TimeUntilRespawn) and tigersharker:TimeUntilRespawn() timeleft1 = IsPosNumber(timeleft1) and timeleft1 or 0 local timeleft2 = IsFunction(tigersharker.TimeUntilCanAppear) and tigersharker:TimeUntilCanAppear() timeleft2 = IsPosNumber(timeleft2) and timeleft2 or 0 local timeleft = math.max(timeleft1, timeleft2) local canSpawn = IsFunction(tigersharker.CanSpawn) and tigersharker:CanSpawn() local nameStr = GetNameString( "tigershark" ) or "" if IsNonEmptyString(nameStr) and (canSpawn or timeleft > 0) then local s = nameStr..(canSpawn and ":"..GetString( "timer_ready" ) or ":"..GetFormattedTime(timeleft)) AddDescLine(lines, s, "tigersharker" ) end end if krakener then local timeleft = IsFunction(krakener.TimeUntilCanSpawn) and krakener:TimeUntilCanSpawn() timeleft = IsPosNumber(timeleft) and timeleft or 0 local canSpawn = IsFunction(krakener.CanSpawn) and krakener:CanSpawn() local nameStr = GetNameString( "kraken" ) or "" if IsNonEmptyString(nameStr) and (canSpawn or timeleft > 0) then local s = nameStr..(canSpawn and ":"..GetString( "timer_ready" ) or ":"..GetFormattedTime(timeleft)) AddDescLine(lines, s, "krakener" ) end end if rocmanager then local spawntime = rocmanager.dycSpawnTime local timeleft = IsNumber(spawntime) and spawntime - GetTime() or 0 local disabled = rocmanager.disabled local nameStr = STRINGS.UI.CUSTOMIZATIONSCREEN.NAMES.ROC or "" if IsNonEmptyString(nameStr) and not disabled and timeleft > 0 then local s = nameStr..":"..GetFormattedTime(timeleft) AddDescLine(lines, s, "rocmanager" ) end end return lines end return DYCGetDescLines 