local G = DYCInfoPanel local require = G.DYCModRequire local GetDetails = require( "dyc_descutil" ) local RGBAColor = G.RGBAColor local StrSpl = G.lib.StrSpl local StringStartWith = G.lib.StringStartWith local conciseList = {prefab = true, boathealth = true, health = true, combat = true, weapon = true, armor = true, tool = true, finiteuses = true, fueled = true, perishable = true, edible = true, inventoryitem = true,} local function HasString(key) return G.localization:HasString(key) end local function GetString(key, default) return G.localization:GetString(key, default) end local function GetActionStrings(itemtile) if not itemtile or not itemtile.GetDescriptionString then return end local action, action2 = nil, nil local desStr = itemtile:GetDescriptionString() if desStr and type(desStr) == "string" and #desStr > 0 then local lines = StrSpl(desStr, "\n" ) if lines then for k, v in pairs(lines) do if v and type(v) == "string" and #v > 0 then if StringStartWith(v, STRINGS.LMB) then action = v end if StringStartWith(v, STRINGS.RMB) then action2 = v end end end end end if action and type(action) == "string" and #action > 0 then local subIndex = 1 for i = 1, #action do local str = string.sub(action, i, i) if str == ":" or str == " " then subIndex = i + 1 end end if subIndex <= #action then action = string.sub(action, subIndex) else action = nil end end return action, action2 end local function FollowObject(inst, widget) local odw = G.objectDetailWindow if odw then local pos = widget and widget:GetWorldPosition() or TheInput:ControllerAttached() and inst and Vector3(TheSim:GetScreenPos(inst.Transform:GetWorldPosition())) or TheInput:GetScreenPosition() local sw, sh = TheSim:GetScreenSize() local w, h = odw:GetSize() local w2, h2 = 0, 0 if widget and widget.bg then w2, h2 = widget.bg:GetSize() elseif widget then w2, h2 = 100, 100 end local posMode = G.cfgs.infopanelpos if posMode and posMode == "auto" then posMode = TheInput:ControllerAttached() and "bl" or "follow" end if posMode and posMode == "tl" then pos = Vector3(0, sh, 0) w2, h2 = 0, 0 elseif posMode and posMode == "bl" then pos = Vector3(0, 0, 0) w2, h2 = 0, 0 elseif posMode and posMode == "tr" then pos = Vector3(sw, sh, 0) w2, h2 = 0, 0 elseif posMode and posMode == "br" then pos = Vector3(sw, 0, 0) w2, h2 = 0, 0 end local ss = odw.screenScale local pw, ph = (w / 2 + w2 / 2 + 30) * ss,(h / 2 + h2 / 2 + 20) * ss local ox = (sw - pos.x < pw and - pw) or (pos.x < pw and pw) or 0 local oy = (sh - pos.y < ph * 2 and - ph) or (pos.y < ph and ph) or (ox ~= 0 and 0) or ph odw:SetOffset(pos + Vector3(ox, oy, 0)) end end local ShowObjectDetail = nil ShowObjectDetail = function(inst, widget, passedAct1String, passedAct2String) local odw = G.objectDetailWindow if odw then odw.focusedObject = inst if not inst then if not widget or widget == odw.hoveredWidget then if odw.shown then odw:Toggle(false) end odw.hoveredWidget = nil end return end if odw.hoveredWidget ~= widget and widget and inst then local DYCDataSyncer = rawget(_G, "DYCDataSyncer" ) if DYCDataSyncer and DYCDataSyncer.SendSyncDataRPC then DYCDataSyncer.SendSyncDataRPC(inst) inst.dycOnSyncFinish = function() if odw.hoveredWidget == widget and not inst.dycTask_SyncFinish then inst.dycTask_SyncFinish = inst:DoTaskInTime(0, function() ShowObjectDetail(inst, widget, passedAct1String, passedAct2String) inst.dycTask_SyncFinish = nil end) end end end end odw.hoveredWidget = widget local stackable = inst.components.stackable local inventoryitem = inst.components.inventoryitem local showRarity = G.cfgs.rarity and inventoryitem ~= nil local prefix = inst:GetAdjective() prefix = prefix and string.gsub(prefix, "\n" , "" ) local name = inst:GetDisplayName() name = name and string.gsub(name, "\n" , "" ) if inst.prefab and name and string.find(string.lower(name), "missing name" ) then name = GetString( "world_"..inst.prefab, name) end local suffix = stackable and stackable.stacksize > 1 and "x"..tostring(stackable.stacksize) or nil local action, action2 = GetActionStrings(widget) action = action or passedAct1String action2 = action2 or passedAct2String action = action and string.gsub(action, "\n" , "" ) action2 = action2 and string.gsub(action2, "\n" , "" ) local rarityStr = inst.GetRarityString and inst:GetRarityString() or nil local rarity = inst.GetRarity and inst:GetRarity() or 0 local rarityColor = inst.GetRarityColor and inst:GetRarityColor() if not showRarity then rarityStr = nil rarityColor = nil end local des = inst.prefab and STRINGS.RECIPE_DESC[string.upper(inst.prefab)] or nil des = des and string.gsub(des, "\n" , "" ) local longDes = inst.GetEnchantmentLongDescription and inst:GetEnchantmentLongDescription() or nil des = (des or "" )..(des and longDes and " " or "" )..(longDes or "" ) des = #des > 0 and des or nil des = des and GetString( "longdesnospace" ) == "true" and string.gsub(des, " " , "" ) or des local lines = GetDetails(inst, G.cfgs.prefab) local inst2, inst2Type = nil, "" if inst and inst.components.rider and inst.components.rider.mount then inst2 = inst.components.rider.mount inst2Type = GetString( "mount" ) elseif inst and inst.components.driver and inst.components.driver.vehicle then inst2 = inst.components.driver.vehicle inst2Type = GetString( "vehicle" ) end if inst2 then local line2s = GetDetails(inst2, G.cfgs.prefab) if #line2s > 0 then local inst2Str = inst2Type..": "..(inst2:GetDisplayName() or "" ) inst2Str = inst2Str and string.gsub(inst2Str, "\n" , "" ) table.insert(lines, {text = inst2Str, color = RGBAColor()}) for k, v in pairs(line2s) do table.insert(lines, v) end end end if not inst:HasTag( "ground" ) and G.cfgs.content and G.cfgs.content == "concise" then local newLines = {} for k, v in pairs(lines) do if v and v.component and conciseList[v.component] then table.insert(newLines, v) end end lines = newLines des = nil end odw:SetObjectDetail({action = action, action2 = action2, prefix = prefix, name = name, nameColor = rarityColor, suffix = suffix, des = des, rarity = rarityStr and rarity > 0 and (GetString( "rarity" )..":"..rarityStr) or nil, lines = lines, encLines = inst.GetEnchantmentLines and inst:GetEnchantmentLines(),}) FollowObject(inst, widget) if not odw.shown then odw:Toggle(true) end end end local mouseObjectDetailInited = false local function InitMouseObjectDetail() mouseObjectDetailInited = true local odw = G.objectDetailWindow TheInput:AddMoveHandler(function(x, y) if odw.hoveredWorldInst then FollowObject() end end) end local lastInst = nil local lastName = nil local lastAction = nil local lastAction2 = nil local lastHp = nil local lastSyncTime = nil local function ShowMouseObjectDetail(inst, act, act2) local odw = G.objectDetailWindow if not odw then return end if not mouseObjectDetailInited then InitMouseObjectDetail() end if odw.hoveredWidget then odw.hoveredWorldInst = nil return end inst = inst ~= nil and not inst:HasTag( "Fx" ) and inst if odw.hoveredWorldInst ~= inst and inst then local DYCDataSyncer = rawget(_G, "DYCDataSyncer" ) if DYCDataSyncer and DYCDataSyncer.SendSyncDataRPC then DYCDataSyncer.SendSyncDataRPC(inst) end end odw.hoveredWorldInst = inst if not inst then if odw.shown then odw:Toggle(false) end lastInst = nil return end if not odw.shown then odw:Toggle(true) end local stackable = inst.components.stackable local name = inst:GetDisplayName() local action = act and act:GetActionString() local action2 = act2 and act2:GetActionString() action2 = action2 and STRINGS.RMB..":"..action2 local health = inst.components.health local hp = health and health.currenthealth hp = hp ~= nil and type(hp) == "number" and hp local syncTime = inst.dycSyncTime if lastSyncTime == syncTime and lastName == name and lastInst == inst and lastAction == action and lastAction2 == action2 and lastHp == hp then return else lastSyncTime = syncTime lastName = name lastInst = inst lastAction = action lastAction2 = action2 lastHp = hp end ShowObjectDetail(inst, nil, action, action2) end local odwutil = {ShowObjectDetail = ShowObjectDetail, ShowMouseObjectDetail = ShowMouseObjectDetail, FollowObject = FollowObject,} return odwutil 