local G = DYCInfoPanel local TableContains = G.lib.TableContains local Round = function(num) return math.floor(num + 0.5) end local Clamp = function(num, min, max) return math.min(math.max(num, min), max) end local function IsNumber(o) return o ~= nil and type(o) == "number" end local function IsPosNumber(o) return IsNumber(o) and o > 0 end local function IsNonNegNumber(o) return IsNumber(o) and o >= 0 end local function IsNegNumber(o) return IsNumber(o) and o < 0 end local function IsNonZeroNumber(o) return IsNumber(o) and o ~= 0 end local function IsString(o) return o ~= nil and type(o) == "string" end local function IsTable(o) return o ~= nil and type(o) == "table" end local function IsFunction(o) return o ~= nil and type(o) == "function" end local function IsNonEmptyString(o) return IsString(o) and #o > 0 end local function ConcatStrings(spl, ...) local tbl = {...} if IsTable(tbl[1]) then tbl = tbl[1] end local result = "" local count = 0 for k, v in pairs(tbl) do if IsNonEmptyString(v) or IsNumber(v) then count = count + 1 result = result..(count > 1 and spl or "" )..v end end return result end local TableCount = function(t) local c = 0 for k, v in pairs(t) do c = c + 1 end return c end local function IsDST() return TheSim:GetGameID() == "DST" end local function DYCGetPlayer() if IsDST() then return ThePlayer else return GetPlayer() end end local function DYCGetWorld() if IsDST() then return TheWorld else return GetWorld() end end local function GetString(key, default) return G.localization:GetString(key, default) end local function GetFormattedTime(s, short, gameunit) if gameunit then local d = s / TUNING.TOTAL_DAY_TIME d = math.floor(d * 10 + 0.5) / 10 return d..GetString( "timer_day" ) end local m = math.max(math.floor(s / 60), 0) local h = math.max(math.floor(m / 60), 0) s = s - m * 60 m = m - h * 60 s = math.floor(s) if short then return(h > 0 and h..GetString( "timer_hour" ) or "" )..(m > 0 and m..GetString( "timer_minute" ) or "" )..(s > 0 and s..GetString( "timer_second" ) or "" ) else return(h > 0 and h..GetString( "timer_hour" ) or "" )..((m > 0 or h > 0) and m..GetString( "timer_minute" ) or "" )..s..GetString( "timer_second" ) end end local function GetNumberString(value) return ""..(value >= 20 and Round(value) or Round(value * 10) / 10) end local function GetPercentString(value) return(value >= 0.2 and Round(value * 100) or Round(value * 1000) / 10).."%" end local function GetSeasonString(s) local str = IsNonEmptyString(s) and STRINGS.UI and STRINGS.UI.SANDBOXMENU and STRINGS.UI.SANDBOXMENU[string.upper(s)] return str end local function GetNameString(prefab) local str = IsNonEmptyString(prefab) and STRINGS.NAMES[string.upper(prefab)] for i = 1, 9 do if str then break end str = str or (IsNonEmptyString(prefab) and STRINGS.NAMES[string.upper(prefab)..i]) end return str end local function BattedGetBatNumber(self) local count = 0 for i, interiorname in ipairs(self.batcaves) do local interiorSpawner = GetWorld().components.interiorspawner local interior = interiorSpawner and interiorSpawner:GetInteriorByName(interiorname) if interior and interior.prefabs and #interior.prefabs > 0 then for i = #interior.prefabs, 1, - 1 do local potentialprefab = interior.prefabs[i] if potentialprefab.name == "vampirebat" then count = count + 1 end end end if interior and interior.object_list and #interior.object_list > 0 then for i = #interior.object_list, 1, - 1 do local prefab = interior.object_list[i] if prefab.prefab == "vampirebat" then count = count + 1 end end end end return count end local function Start(watcher) if not G.cfgs.notifications then return end local colorDanger = {1, 0, 0} local colorWarning = {1, 0.5, 0} local colorNormal = {1, 1, 1} local world = DYCGetWorld() local comps = world and world.components local hounded = comps and comps.hounded local hounded_warned1 = false local hounded_wt1 = 120 local hounded_warned2 = false local hounded_wt2 = 600 local hounded_attacked = false local batted = comps and comps.batted local batted_warned1 = false local batted_wt1 = 120 local batted_warned2 = false local batted_wt2 = 600 local batted_lt = 999999 local batted_ln = 0 local volcanomanager = comps and comps.volcanomanager local vm_warned1 = false local vm_wt1 = 30 local vm_warned2 = false local vm_wt2 = 120 local vm_warned3 = false local vm_wt3 = 480 local vm_lt = 999999 local vm_none = false local basehassler = comps and comps.basehassler local basehassler_warned = {} local basehassler_lt = {} local basehassler_wt1 = 59 local basehassler_wt2 = 480 local basehassler_wt3 = 10800 local rocmanager = comps and comps.rocmanager local rocmanager_warned = {false, false, false} local rocmanager_wt = {120, 480, 10800} local rocmanager_lt = 999999 local interval = 0.5 local timer = 0 world:DoPeriodicTask(FRAMES, function() timer = timer + FRAMES if timer >= interval then timer = 0 if hounded then local timetoattack = hounded.timetoattack timetoattack = IsNumber(timetoattack) and timetoattack or 0 local houndstorelease = hounded.houndstorelease houndstorelease = IsNumber(houndstorelease) and houndstorelease or 0 local shouldWarn = false if not hounded_warned1 and timetoattack <= hounded_wt1 then shouldWarn = true elseif not hounded_warned2 and timetoattack <= hounded_wt2 then shouldWarn = true end if shouldWarn then local str = GetString( "timer_warning" )..": "..string.format(GetString( "houndtimer" ), Round(houndstorelease), GetFormattedTime(timetoattack)) G.PushBanner(str, 12, colorWarning, true) end if not hounded_attacked and timetoattack <= 0 then G.PushBanner(GetString( "watcher_houndattack" ), 12, colorDanger, true) end if timetoattack > hounded_wt1 then hounded_warned1 = false else hounded_warned1 = true end if timetoattack > hounded_wt2 then hounded_warned2 = false else hounded_warned2 = true end if timetoattack > 0 then hounded_attacked = false else hounded_attacked = true end end if batted then local timetoattack = batted.timetoattack local batnum = BattedGetBatNumber(batted) batnum = IsNumber(batnum) and batnum or 0 local shouldWarn = false if not batted_warned1 and timetoattack <= batted_wt1 then shouldWarn = true elseif not batted_warned2 and timetoattack <= batted_wt2 then shouldWarn = true end if shouldWarn then local str = GetString( "timer_warning" )..": "..string.format(GetString( "battimer" ), Round(batnum), GetFormattedTime(timetoattack)) G.PushBanner(str, 12, colorWarning, true) end if batted_lt < timetoattack and batted_ln > 0 then G.PushBanner(GetString( "watcher_batattack" ), 12, colorDanger, true) end if timetoattack > batted_wt1 then batted_warned1 = false else batted_warned1 = true end if timetoattack > batted_wt2 then batted_warned2 = false else batted_warned2 = true end batted_lt = timetoattack batted_ln = batnum end if volcanomanager then local segs = IsFunction(volcanomanager.GetNumSegmentsUntilEruption) and volcanomanager:GetNumSegmentsUntilEruption() local segtime = IsNonNegNumber(TUNING.SEG_TIME) and TUNING.SEG_TIME local daytime = IsNonNegNumber(TUNING.TOTAL_DAY_TIME) and TUNING.TOTAL_DAY_TIME if IsNonNegNumber(segs) and segtime and daytime then local timeleftinseg = math.floor(daytime * GetClock():GetNormTime() / segtime) * segtime timeleftinseg = daytime * GetClock():GetNormTime() - timeleftinseg local timeleft = segs * segtime - timeleftinseg local shouldWarn = false if vm_none then shouldWarn = true elseif not vm_warned1 and timeleft <= vm_wt1 then shouldWarn = true elseif not vm_warned2 and timeleft <= vm_wt2 then shouldWarn = true elseif not vm_warned3 and timeleft <= vm_wt3 then shouldWarn = true end if shouldWarn then local str = GetString( "timer_warning" )..": "..string.format(GetString( "volcanotimer" ), GetFormattedTime(timeleft)) G.PushBanner(str, 12, colorWarning, true) end if vm_lt < timeleft and vm_lt <= 2 then G.PushBanner(GetString( "watcher_volcano" ), 12, colorDanger, true) end if timeleft > vm_wt1 then vm_warned1 = false else vm_warned1 = true end if timeleft > vm_wt2 then vm_warned2 = false else vm_warned2 = true end if timeleft > vm_wt3 then vm_warned3 = false else vm_warned3 = true end vm_lt = timeleft vm_none = false else vm_lt = 999999 vm_none = true end end if basehassler then local hasslers = basehassler.hasslers if IsTable(hasslers) and next(hasslers) then for k, hassler in pairs(hasslers) do local timer = IsTable(hassler) and hassler.timer local prefab = IsTable(hassler) and hassler.prefab local state = IsFunction(basehassler.GetHasslerState) and basehassler:GetHasslerState(k) local stateStr = IsNonEmptyString(state) and (state == "WAITING" or state == "WARNING" ) and "("..GetString( "timer_"..state)..")" or "" if not basehassler_warned[hassler] then basehassler_warned[hassler] = {[1] = false,[2] = false,[3] = false} end local warned = basehassler_warned[hassler] if IsNumber(timer) and IsNonEmptyString(prefab) and IsNonEmptyString(stateStr) then basehassler_lt[hassler] = timer local shouldWarn = false if not warned[1] and timer <= basehassler_wt1 then shouldWarn = true elseif not warned[2] and timer <= basehassler_wt2 then shouldWarn = true elseif not warned[3] and timer <= basehassler_wt3 then shouldWarn = true end if timer > basehassler_wt1 then warned[1] = false else warned[1] = true end if timer > basehassler_wt2 then warned[2] = false else warned[2] = true end if timer > basehassler_wt3 then warned[3] = false else warned[3] = true end if shouldWarn then local nameStr = GetNameString(hassler.prefab) or "" if IsNonEmptyString(nameStr) then local s = nameStr..stateStr..":"..GetFormattedTime(timer) G.PushBanner(s, 12, colorWarning, true) end end elseif IsTable(hassler) then if warned[1] or warned[2] or warned[3] then warned[1] = false warned[2] = false warned[3] = false local nameStr = GetNameString(hassler.prefab) or "" if IsNonEmptyString(nameStr) and IsNumber(basehassler_lt[hassler]) and basehassler_lt[hassler] <= 2 then G.PushBanner(string.format(GetString( "watcher_hassler" ), nameStr), 12, colorDanger, true) end basehassler_lt[hassler] = 999999 end end end end end if rocmanager then local spawntime = rocmanager.dycSpawnTime local timeleft = IsNumber(spawntime) and spawntime - GetTime() or 0 local disabled = rocmanager.disabled local nameStr = STRINGS.UI.CUSTOMIZATIONSCREEN.NAMES.ROC or "" if IsNonEmptyString(nameStr) and not disabled and timeleft >= 0 then local shouldWarn = false for i = 1, #rocmanager_warned do if not rocmanager_warned[i] and IsNumber(rocmanager_wt[i]) and timeleft <= rocmanager_wt[i] and timeleft >= 1 then shouldWarn = true break end end for i = 1, #rocmanager_warned do if IsNumber(rocmanager_wt[i]) and timeleft > rocmanager_wt[i] then rocmanager_warned[i] = false else rocmanager_warned[i] = true end end if shouldWarn then local s = nameStr..":"..GetFormattedTime(timeleft) G.PushBanner(s, 12, colorNormal) end if timeleft < interval and timeleft ~= rocmanager_lt and rocmanager_lt <= 2 then G.PushBanner(string.format(GetString( "watcher_hassler" ), nameStr), 12, colorNormal) end rocmanager_lt = timeleft else rocmanager_lt = 999999 end end end end) end local Watcher = {} function Watcher:Start() Start(self) end return Watcher 