local Widget = require "widgets/widget" local Image = require "widgets/image" local Text = require "widgets/text" local Screen = require "widgets/screen" local Button = require "widgets/button" local Spinner = require "widgets/spinner" local dycguis = {} dycguis.Init = function(self, data) if self.initialized then return end self.initialized = true self.localization = data.localization self.multiLineScale = data.multiLineScale self.textWidthScale = data.textWidthScale self.language = data.language end local function IsRail() return string.upper(PLATFORM) == "WIN32" end local function IsDST() return TheSim:GetGameID() == "DST" end local function DYCGetPlayer() if IsDST() then return ThePlayer else return GetPlayer() end end local function DYCGetWorld() if IsDST() then return TheWorld else return GetWorld() end end local GetString = function(key, default) local strs = dycguis.localization.strings or dycguis.localization:GetStrings() return strs:GetString(key, default) end local GetScreenScale = function() local sw, sh = TheSim:GetScreenSize() return sw / 1920 end local GetMouseScreenPos = function() return TheSim:GetScreenPos(TheInput:GetWorldPosition():Get()) end local RGBAColor = function(r, g, b, a) return {r = r or 1, g = g or 1, b = b or 1, a = a or 1, Get = function(self) return self.r, self.g, self.b, self.a end, R = function(self, r) self.r = r return self end, G = function(self, g) self.g = g return self end, B = function(self, b) self.b = b return self end, A = function(self, a) self.a = a return self end,} end local Lerp = function(a, b, p) return a + (b - a) * p end local function StrSpl(str, sep) if sep == nil then sep = "%s" end local t = {} local i = 1 for s in string.gmatch(str, "([^"..sep.."]+)" ) do t[i] = s i = i + 1 end return t end local TableContains = function(t, value) for k, v in pairs(t) do if v == value then return true end end return false end local TableAdd = function(t, value) if not TableContains(t, value) then table.insert(t, value) end end local TableGetIndex = function(t, value) for k, v in pairs(t) do if v == value then return k end end end local TableRemoveValue = function(t, value) local index = TableGetIndex(t, value) if index then table.remove(t, index) end end local DYC_Root = Class(Widget, function(self, data) Widget._ctor(self, "DYC_Root" ) self.keepTop = data.keepTop self.moveLayerTimer = 0 if data.keepTop then self:StartUpdating() end end) function DYC_Root:OnUpdate(dt) dt = dt or 0 self.moveLayerTimer = self.moveLayerTimer + dt if self.keepTop and self.moveLayerTimer > 0.5 then self.moveLayerTimer = 0 self:MoveToFront() end end dycguis.Root = DYC_Root local DYC_Text = Class(Text, function(self, font, size, text, hittest) if font and type(font) == "table" then local data = font Text._ctor(self, data.font or NUMBERFONT, data.fontSize or 30, data.text) if data.color then local c = data.color self:SetColor(c.r or c[1] or 1, c.g or c[2] or 1, c.b or c[3] or 1, c.a or c[4] or 1) end if data.regionSize then self:SetRegionSize(data.regionSize.w, data.regionSize.h) end self.alignH = data.alignH self.alignV = data.alignV self.focusFn = data.focusFn self.unfocusFn = data.unfocusFn self.hittest = data.hittest else Text._ctor(self, font or NUMBERFONT, size or 30, text) self.hittest = hittest if text then self:SetText(text) end end end) function DYC_Text:GetImage() if not self.image then self.image = self:AddChild(Image( "images/ui.xml" , "button.tex" )) self.image:MoveToBack() self.image:SetTint(0, 0, 0, 0) end return self.image end function DYC_Text:SetText(str) local oldWidth = self:GetWidth() local oldHeight = self:GetHeight() local pos = self:GetPosition() self:SetString(str) if self.alignH and self.alignH ~= ANCHOR_MIDDLE then local newWidth = self:GetWidth() pos.x = pos.x + (newWidth - oldWidth) / 2 * (self.alignH == ANCHOR_LEFT and 1 or - 1) end if self.alignV and self.alignV ~= ANCHOR_MIDDLE then local newHeight = self:GetHeight() pos.y = pos.y + (newHeight - oldHeight) / 2 * (self.alignV == ANCHOR_BOTTOM and 1 or - 1) end if self.alignH or self.alignV then self:SetPosition(pos) end if self.hittest then self:GetImage():SetSize(self:GetSize()) end end function DYC_Text:SetColor(...) self:SetColour(...) end function DYC_Text:GetRegionSize() local w, h = DYC_Text._base.GetRegionSize(self) w = w * (dycguis.textWidthScale or 1) return w, h end function DYC_Text:GetWidth() local w, h = self:GetRegionSize() w = w < 10000 and w or 0 return w end function DYC_Text:GetHeight() local w, h = self:GetRegionSize() h = h < 10000 and h or 0 return h end function DYC_Text:GetSize() local w, h = self:GetRegionSize() w = w < 10000 and w or 0 h = h < 10000 and h or 0 return w, h end function DYC_Text:OnGainFocus() DYC_Text._base.OnGainFocus(self) if self.focusFn then self.focusFn(self) end end function DYC_Text:OnLoseFocus() DYC_Text._base.OnLoseFocus(self) if self.unfocusFn then self.unfocusFn(self) end end function DYC_Text:AnimateIn(speed) self.textString = self.string self.animSpeed = speed or 60 self.animIndex = 0 self.animTimer = 0 self:SetText( "" ) self:StartUpdating() end function DYC_Text:OnUpdate(dt) dt = dt or 0 if DYC_Text._base.OnUpdate then DYC_Text._base.OnUpdate(self, dt) end if dt > 0 and self.animIndex and self.textString and #self.textString > 0 then self.animTimer = self.animTimer + dt if self.animTimer > 1 / self.animSpeed then self.animTimer = 0 self.animIndex = self.animIndex + 1 if self.animIndex > #self.textString then self.animIndex = nil self:SetText(self.textString) else local ascii = string.byte(string.sub(self.textString, self.animIndex, self.animIndex)) if ascii and ascii > 127 then self.animIndex = self.animIndex + 2 end self:SetText(string.sub(self.textString, 1, self.animIndex)) end end end end dycguis.Text = DYC_Text local DYC_SlicedImage = Class(Widget, function(self, data) Widget._ctor(self, "DYC_SlicedImage" ) self.images = {} self.mode = "slice13" self.texScale = data.texScale or 1 self.width = 100 self.height = 100 self:SetTextures(data) end) function DYC_SlicedImage:__tostring() return string.format( "%s (%s)" , self.name, self.mode) end function DYC_SlicedImage:SetTextures(data) assert(data.mode) self.images = {} self.mode = data.mode if self.mode == "slice13" or self.mode == "slice31" then local img = nil img = self:AddChild(Image(data.atlas, data.texname.."_1.tex" )) img.oriW, img.oriH = img:GetSize() img.imgPos = 1 self.images[1] = img img = self:AddChild(Image(data.atlas, data.texname.."_2.tex" )) img.oriW, img.oriH = img:GetSize() img.imgPos = 2 self.images[2] = img img = self:AddChild(Image(data.atlas, data.texname.."_3.tex" )) img.oriW, img.oriH = img:GetSize() img.imgPos = 3 self.images[3] = img if self.mode == "slice13" then assert(self.images[1].oriH == self.images[3].oriH, "Height must be equal!" ) assert(self.images[1].oriH == self.images[2].oriH, "Height must be equal!" ) else assert(self.images[1].oriW == self.images[3].oriW, "Width must be equal!" ) assert(self.images[1].oriW == self.images[2].oriW, "Width must be equal!" ) end return elseif self.mode == "slice33" then local img = nil for i = 1, 3 do for j = 1, 3 do img = self:AddChild(Image(data.atlas, data.texname.."_"..i..j..".tex" )) img.oriW, img.oriH = img:GetSize() img.imgPos = i * 10 + j self.images[i * 10 + j] = img if i > 1 then assert(self.images[i * 10 + j].oriW == self.images[(i - 1) * 10 + j].oriW, "Width must be equal!" ) end if j > 1 then assert(self.images[i * 10 + j].oriH == self.images[i * 10 + j - 1].oriH, "Height must be equal!" ) end end end return end error( "Mode not supported!" ) self:SetSize() end function DYC_SlicedImage:SetSize(w, h) w = w or self.width h = h or self.height if self.mode == "slice13" then local img1 = self.images[1] local img2 = self.images[2] local img3 = self.images[3] local scale = math.min(self.texScale, math.min(w / (img1.oriW + img3.oriW), h / img1.oriH)) local w1 = img1.oriW * scale local w3 = img3.oriW * scale local w2 = math.max(0, w - w1 - w3) img1:SetSize(w1, h) img2:SetSize(w2, h) img3:SetSize(w3, h) local x2 = (w1 - w3) / 2 local x1 = - w1 / 2 - w2 / 2 + x2 local x3 = w3 / 2 + w2 / 2 + x2 img1:SetPosition(x1, 0, 0) img2:SetPosition(x2, 0, 0) img3:SetPosition(x3, 0, 0) self.width = w1 + w2 + w3 self.height = h elseif self.mode == "slice31" then local img1 = self.images[1] local img2 = self.images[2] local img3 = self.images[3] local scale = math.min(self.texScale, math.min(h / (img1.oriH + img3.oriH), w / img1.oriW)) local h1 = img1.oriH * scale local h3 = img3.oriH * scale local h2 = math.max(0, h - h1 - h3) img1:SetSize(w, h1) img2:SetSize(w, h2) img3:SetSize(w, h3) local y2 = (h1 - h3) / 2 local y1 = - h1 / 2 - h2 / 2 + y2 local y3 = h3 / 2 + h2 / 2 + y2 img1:SetPosition(0, y1, 0) img2:SetPosition(0, y2, 0) img3:SetPosition(0, y3, 0) self.height = h1 + h2 + h3 self.width = w elseif self.mode == "slice33" then local imgs = self.images local scale = math.min(self.texScale, math.min(w / (imgs[11].oriW + imgs[13].oriW), h / (imgs[11].oriH + imgs[31].oriH))) local ws, hs, xs, ys = {}, {}, {}, {} ws[1] = imgs[11].oriW * scale ws[3] = imgs[13].oriW * scale ws[2] = math.max(0, w - ws[1] - ws[3]) hs[1] = imgs[11].oriH * scale hs[3] = imgs[31].oriH * scale hs[2] = math.max(0, h - hs[1] - hs[3]) xs[2] = (ws[1] - ws[3]) / 2 xs[1] = - ws[1] / 2 - ws[2] / 2 + xs[2] xs[3] = ws[3] / 2 + ws[2] / 2 + xs[2] ys[2] = (hs[1] - hs[3]) / 2 ys[1] = - hs[1] / 2 - hs[2] / 2 + ys[2] ys[3] = hs[3] / 2 + hs[2] / 2 + ys[2] for i = 1, 3 do for j = 1, 3 do imgs[i * 10 + j]:SetSize(ws[j], hs[i]) imgs[i * 10 + j]:SetPosition(xs[j], ys[i], 0) end end self.width = ws[1] + ws[2] + ws[3] self.height = hs[1] + hs[2] + hs[3] end end function DYC_SlicedImage:GetSize() return self.width, self.height end function DYC_SlicedImage:SetTint(r, g, b, a) for k, v in pairs(self.images) do v:SetTint(r, g, b, a) end end function DYC_SlicedImage:SetClickable(b) for k, v in pairs(self.images) do v:SetClickable(b) end end dycguis.SlicedImage = DYC_SlicedImage local DYC_Spinner = Class(Spinner, function(self, options, width, height, textinfo, editable, atlas, textures) Spinner._ctor(self, options, width, height, textinfo, editable, atlas, textures) end) function DYC_Spinner:GetSelectedHint() return self.options[self.selectedIndex].hint or "" end function DYC_Spinner:SetSelected(data, data2) if data == nil and data2 ~= nil then return self:SetSelected(data2) end for k, v in pairs(self.options) do if v.data == data then self:SetSelectedIndex(k) return true end end if data2 then return self:SetSelected(data2) else return false end end function DYC_Spinner:SetSelectedIndex(idx, ...) DYC_Spinner._base.SetSelectedIndex(self, idx, ...) if self.setSelectedIndexFn then self.setSelectedIndexFn(self) end end function DYC_Spinner:OnGainFocus() DYC_Spinner._base.OnGainFocus(self) if self.focusFn then self.focusFn(self) end end function DYC_Spinner:OnLoseFocus() DYC_Spinner._base.OnLoseFocus(self) if self.unfocusFn then self.unfocusFn(self) end end function DYC_Spinner:OnMouseButton(button, down, x, y, ...) DYC_Spinner._base.OnMouseButton(self, button, down, x, y, ...) if not down and button == MOUSEBUTTON_LEFT then if self.mouseLeftUpFn then self.mouseLeftUpFn(self) end end if not self.focus then return false end if down and button == MOUSEBUTTON_LEFT then if self.mouseLeftDownFn then self.mouseLeftDownFn(self) end end end dycguis.Spinner = DYC_Spinner local DYC_ImageButton = Class(Button, function(self, data) Button._ctor(self, "DYC_ImageButton" ) data = data or {} local atlas, normal, focus, disabled = data.atlas, data.normal, data.focus, data.disabled atlas = atlas or "images/ui.xml" normal = normal or "button.tex" focus = focus or "button_over.tex" disabled = disabled or "button_disabled.tex" self.width = data.width or 100 self.height = data.height or 30 self.screenScale = 0.9999 self.moveLayerTimer = 0 self.followScreenScale = data.followScreenScale self.draggable = data.draggable if data.draggable then self.clickoffset = Vector3(0, 0, 0) end self.dragging = false self.draggingTimer = 0 self.draggingPos = {x = 0, y = 0} self.keepTop = data.keepTop self.image = self:AddChild(Image()) self.image:MoveToBack() self.atlas = atlas self.image_normal = normal self.image_focus = focus or normal self.image_disabled = disabled or normal self.color_normal = data.colornormal or RGBAColor() self.color_focus = data.colorfocus or RGBAColor() self.color_disabled = data.colordisabled or RGBAColor() if data.cb then self:SetOnClick(data.cb) end if data.text then self:SetText(data.text) self:SetFont(data.font or NUMBERFONT) self:SetTextSize(data.fontSize or self.height * 0.75) local r, g, b, a = 1, 1, 1, 1 if data.textColor then r = data.textColor.r;g = data.textColor.g; b = data.textColor.b;a = data.textColor.a end self:SetTextColour(r, g, b, a) end self:SetTexture(self.atlas, self.image_normal) self:StartUpdating() end) function DYC_ImageButton:SetSize(w, h) w = w or self.width; h = h or self.height self.width = w; self.height = h self.image:SetSize(self.width, self.height) end function DYC_ImageButton:GetSize() return self.image:GetSize() end function DYC_ImageButton:SetTexture(atlas, tex) self.image:SetTexture(atlas, tex) self:SetSize() local c = self.color_normal self.image:SetTint(c.r, c.g, c.b, c.a) end function DYC_ImageButton:SetTextures(atlas, normal, focus, disabled) local default_textures = false if not atlas then atlas = atlas or "images/frontend.xml" normal = normal or "button_long.tex" focus = focus or "button_long_halfshadow.tex" disabled = disabled or "button_long_disabled.tex" default_textures = true end self.atlas = atlas self.image_normal = normal self.image_focus = focus or normal self.image_disabled = disabled or normal if self:IsEnabled() then if self.focus then self:OnGainFocus() else self:OnLoseFocus() end else self:OnDisable() end end function DYC_ImageButton:OnGainFocus() DYC_ImageButton._base.OnGainFocus(self) if self:IsEnabled() then self:SetTexture(self.atlas, self.image_focus) local c = self.color_focus self.image:SetTint(c.r, c.g, c.b, c.a) end if self.image_focus == self.image_normal then self.image:SetScale(1.2, 1.2, 1.2) end if self.focusFn then self.focusFn(self) end end function DYC_ImageButton:OnLoseFocus() DYC_ImageButton._base.OnLoseFocus(self) if self:IsEnabled() then self:SetTexture(self.atlas, self.image_normal) local c = self.color_normal self.image:SetTint(c.r, c.g, c.b, c.a) end if self.image_focus == self.image_normal then self.image:SetScale(1, 1, 1) end if self.unfocusFn then self.unfocusFn(self) end end function DYC_ImageButton:OnMouseButton(button, down, x, y, ...) DYC_ImageButton._base.OnMouseButton(self, button, down, x, y, ...) if not down and button == MOUSEBUTTON_LEFT and self.dragging then self.dragging = false if self.dragEndFn then self.dragEndFn(self) end end if not self.focus then return false end if self.draggable and button == MOUSEBUTTON_LEFT then if down then self.dragging = true self.draggingPos.x = x self.draggingPos.y = y end end end function DYC_ImageButton:OnControl(control, down, ...) if self.draggingTimer <= 0.3 then if DYC_ImageButton._base.OnControl(self, control, down, ...) then self:StartUpdating() return true end self:StartUpdating() end if not self:IsEnabled() or not self.focus then return end end function DYC_ImageButton:Enable() DYC_ImageButton._base.Enable(self) self:SetTexture(self.atlas, self.focus and self.image_focus or self.image_normal) local c = self.focus and self.color_focus or self.color_normal self.image:SetTint(c.r, c.g, c.b, c.a) if self.image_focus == self.image_normal then if self.focus then self.image:SetScale(1.2, 1.2, 1.2) else self.image:SetScale(1, 1, 1) end end end function DYC_ImageButton:Disable() DYC_ImageButton._base.Disable(self) self:SetTexture(self.atlas, self.image_disabled) local c = self.color_disabled or self.color_normal self.image:SetTint(c.r, c.g, c.b, c.a) end function DYC_ImageButton:OnUpdate(dt) dt = dt or 0 local newss = GetScreenScale() if self.followScreenScale and newss ~= self.screenScale then self:SetScale(newss) local offset = self:GetPosition() offset.x = offset.x * newss / self.screenScale offset.y = offset.y * newss / self.screenScale self.o_pos = offset self:SetPosition(offset) self.screenScale = newss end if self.draggable and self.dragging then self.draggingTimer = self.draggingTimer + dt local x, y = GetMouseScreenPos() local dx = x - self.draggingPos.x local dy = y - self.draggingPos.y self.draggingPos.x = x; self.draggingPos.y = y local offset = self:GetPosition() offset.x = offset.x + dx; offset.y = offset.y + dy self.o_pos = offset self:SetPosition(offset) end if not self.dragging then self.draggingTimer = 0 end self.moveLayerTimer = self.moveLayerTimer + dt if self.keepTop and self.moveLayerTimer > 0.5 then self.moveLayerTimer = 0 self:MoveToFront() end end dycguis.ImageButton = DYC_ImageButton local DYC_Window = Class(Widget, function(self) Widget._ctor(self, "DYC_Window" ) self.width = 400 self.height = 300 self.paddingX = 40 self.paddingY = 42 self.screenScale = 0.9999 self.currentLineY = 0 self.currentLineX = 0 self.lineHeight = 35 self.lineSpacingX = 10 self.lineSpacingY = 3 self.fontSize = self.lineHeight * 0.9 self.font = NUMBERFONT self.titleFontSize = 40 self.titleFont = NUMBERFONT self.titleColor = RGBAColor(1, 0.7, 0.4) self.draggable = true self.dragging = false self.draggingPos = {x = 0, y = 0} self.draggableChildren = {} self.moveLayerTimer = 0 self.keepTop = false self.currentPageIndex = 1 self.pages = {} self.animTargetSize = nil self.bg = self:AddChild(DYC_SlicedImage({mode = "slice33" , atlas = "images/dyc_panel_shadow.xml" , texname = "dyc_panel_shadow" , texScale = 1.0,})) self.bg:SetSize(self.width, self.height) self.bg:SetTint(1, 1, 1, 1) self:SetCenterAlignment() self:AddDraggableChild(self.bg, true) self.root = self.bg:AddChild(Widget( "root" )) self.rootTL = self.root:AddChild(Widget( "rootTL" )) self.rootT = self.root:AddChild(Widget( "rootT" )) self.rootTR = self.root:AddChild(Widget( "rootTR" )) self.rootL = self.root:AddChild(Widget( "rootL" )) self.rootM = self.root:AddChild(Widget( "rootM" )) self.rootR = self.root:AddChild(Widget( "rootR" )) self.rootB = self.root:AddChild(Widget( "rootB" )) self.rootBL = self.root:AddChild(Widget( "rootBL" )) self.rootBR = self.root:AddChild(Widget( "rootBR" )) self:SetSize() self:SetOffset(0, 0, 0) self:StartUpdating() end) function DYC_Window:SetBottomLeftAlignment() self.bg:SetVAnchor(ANCHOR_BOTTOM) self.bg:SetHAnchor(ANCHOR_LEFT) end function DYC_Window:SetTopLeftAlignment() self.bg:SetVAnchor(ANCHOR_TOP) self.bg:SetHAnchor(ANCHOR_LEFT) end function DYC_Window:SetCenterAlignment() self.bg:SetVAnchor(ANCHOR_MIDDLE) self.bg:SetHAnchor(ANCHOR_MIDDLE) end function DYC_Window:SetOffset(...) self.bg:SetPosition(...) end function DYC_Window:GetOffset() return self.bg:GetPosition() end function DYC_Window:SetSize(w, h) w = w or self.width; h = h or self.height self.width = w; self.height = h self.bg:SetSize(w, h) self.rootTL:SetPosition( - w / 2, h / 2, 0) self.rootT:SetPosition(0, h / 2, 0) self.rootTR:SetPosition(w / 2, h / 2, 0) self.rootL:SetPosition( - w / 2, 0, 0) self.rootM:SetPosition(0, 0, 0) self.rootR:SetPosition(w / 2, 0, 0) self.rootBL:SetPosition( - w / 2, - h / 2, 0) self.rootB:SetPosition(0, - h / 2, 0) self.rootBR:SetPosition(w / 2, - h / 2, 0) end function DYC_Window:GetSize() return self.width, self.height end function DYC_Window:SetTitle(str, font, fontSize, c) if not self.title then self.title = self.rootT:AddChild(DYC_Text(NUMBERFONT, 10)) end str = str or self.title:GetString() ; font = font or self.titleFont; fontSize = fontSize or self.titleFontSize; c = c or self.titleColor self.titleFont = font; self.titleFontSize = fontSize; self.titleColor = c self.title:SetString(str) self.title:SetFont(font) self.title:SetSize(fontSize) self.title:SetPosition(0, - fontSize / 2 * 1.3 - self.paddingY, 0) self.title:SetColor(c.r or c[1] or 1, c.g or c[2] or 1, c.b or c[3] or 1, c.a or c[4] or 1) end function DYC_Window:GetPage(pageIndex) pageIndex = pageIndex or self.currentPageIndex pageIndex = math.max(1, math.floor(pageIndex)) while self.pages[pageIndex] == nil do table.insert(self.pages, {root = self.rootTL:AddChild(Widget( "rootPage"..pageIndex)), contents = {},}) end return self.pages[pageIndex] end function DYC_Window:SetCurrentPage(pageIndex) pageIndex = math.max(1, math.floor(pageIndex)) self.currentPageIndex = pageIndex self.currentLineY = 0 self.currentLineX = 0 return self:GetPage() end function DYC_Window:ShowPage(pageIndex) pageIndex = pageIndex or self.currentPageIndex pageIndex = math.max(1, math.min(math.floor(pageIndex), #self.pages)) self:SetCurrentPage(pageIndex) for i = 1, #self.pages do self:ToggleContents(i, i == pageIndex) end if self.pageChangeFn then self.pageChangeFn(self, pageIndex) end end function DYC_Window:ShowNextPage() local pageIndex = self.currentPageIndex + 1 if pageIndex > #self.pages then pageIndex = 1 end self:ShowPage(pageIndex) end function DYC_Window:ShowPreviousPage() local pageIndex = self.currentPageIndex - 1 if pageIndex < 1 then pageIndex = #self.pages end self:ShowPage(pageIndex) end function DYC_Window:ClearPages() if #self.pages <= 0 then return end for i = 1, #self.pages do self:ClearContents(i) end end function DYC_Window:AddContent(w, width) local page = self:GetPage() local uie = page.root:AddChild(w) if not width then if uie.GetRegionSize then width = uie:GetRegionSize() elseif uie.GetWidth then width = uie:GetWidth() elseif uie.width then width = uie.width end end width = width or 100 uie:SetPosition(self.paddingX + self.currentLineX + width / 2, - self.paddingY - self.currentLineY - self.lineHeight * 0.5, 0) self.currentLineX = self.currentLineX + width + self.lineSpacingX TableAdd(page.contents, uie) return uie end function DYC_Window:ToggleContents(pageIndex, b) local page = self:GetPage(pageIndex) if b then page.root:Show() else page.root:Hide() end end function DYC_Window:ClearContents(pageIndex) pageIndex = pageIndex or self.currentPageIndex for k, v in pairs(self:GetPage(pageIndex).contents) do v:Kill() end self:GetPage(pageIndex).contents = {} self.currentLineY = 0 self.currentLineX = 0 end function DYC_Window:NewLine(k) self.currentLineY = self.currentLineY + (k or 1) * self.lineHeight + self.lineSpacingY self.currentLineX = 0 end function DYC_Window:AddDraggableChild(child, includeChildren) TableAdd(self.draggableChildren, child) if includeChildren then for k, v in pairs(child.children) do self:AddDraggableChild(v, true) end end end function DYC_Window:OnRawKey(key, down, ...) local returnValue = DYC_Window._base.OnRawKey(self, key, down, ...) if not self.focus then return false end return returnValue end function DYC_Window:OnControl(control, down, ...) local returnValue = DYC_Window._base.OnControl(self, control, down, ...) if not self.focus then return false end return returnValue end function DYC_Window:OnMouseButton(button, down, x, y, ...) local returnValue = DYC_Window._base.OnMouseButton(self, button, down, x, y, ...) if not down and button == MOUSEBUTTON_LEFT then self.dragging = false end if not self.focus then return false end if self.draggable and button == MOUSEBUTTON_LEFT then if down then local deepestFocus = self:GetDeepestFocus() if deepestFocus and TableContains(self.draggableChildren, deepestFocus) then self.dragging = true self.draggingPos.x = x self.draggingPos.y = y end end end return returnValue end function DYC_Window:Toggle(b, isOK) b = b ~= nil and b or not self.shown if b then self:Show() else self:Hide() end if self.toggleFn then self.toggleFn(self, b) end if not b and isOK and self.okFn then self.okFn(self) end if not b and not isOK and self.cancelFn then self.cancelFn(self) end end function DYC_Window:AnimateSize(tw, th, speed) if tw and th then self.animTargetSize = {w = tw, h = th} self.animSpeed = speed or 5 end end function DYC_Window:OnUpdate(dt) dt = dt or 0 if self.animTargetSize and dt > 0 then local w, h = self:GetSize() if math.abs(w - self.animTargetSize.w) < 1 then self:SetSize(self.animTargetSize.w, self.animTargetSize.h) self.animTargetSize = nil else self:SetSize(Lerp(w, self.animTargetSize.w, self.animSpeed * dt), Lerp(h, self.animTargetSize.h, self.animSpeed * dt)) end end local newss = GetScreenScale() if newss ~= self.screenScale then self.bg:SetScale(newss) local offset = self:GetOffset() offset.x = offset.x * newss / self.screenScale offset.y = offset.y * newss / self.screenScale self:SetOffset(offset) self.screenScale = newss end if self.draggable and self.dragging then local x, y = GetMouseScreenPos() local dx = x - self.draggingPos.x local dy = y - self.draggingPos.y self.draggingPos.x = x; self.draggingPos.y = y local offset = self:GetOffset() offset.x = offset.x + dx; offset.y = offset.y + dy self:SetOffset(offset) end self.moveLayerTimer = self.moveLayerTimer + dt if self.keepTop and self.moveLayerTimer > 0.5 then self.moveLayerTimer = 0 self:MoveToFront() end end dycguis.Window = DYC_Window local DYC_Banner = Class(DYC_Window, function(self, data) DYC_Window._ctor(self) self:SetTopLeftAlignment() self.bg:SetClickable(false) self.bg:SetTint(1, 1, 1, 0) self.paddingX = 35 self.paddingY = 35 self.lineHeight = 32 self.fontSize = 32 self.font = DEFAULTFONT self.bannerColor = data.color or RGBAColor() self.bannerText = self:AddContent(DYC_Text({font = self.font, fontSize = self.fontSize, alignH = ANCHOR_LEFT, text = data.text or "???" , color = self.bannerColor,})) local windowW, windowH = self.currentLineX + self.paddingX * 2, self.lineHeight + self.paddingY * 2 self:SetSize(windowW, windowH) self.windowW = windowW self.bannerText:AnimateIn() self:SetOffset(700, - windowH / 2) self.shouldFadeIn = true self.bannerOpacity = 0 self.bannerTimer = data.duration or 5 self.bannerIndex = 1 end) function DYC_Banner:SetShouldFadeOut() self.shouldFadeIn = false end function DYC_Banner:OnUpdate(dt) DYC_Banner._base.OnUpdate(self, dt) dt = dt or 0 if dt > 0 then self.bannerTimer = self.bannerTimer - dt if self.shouldFadeIn then self.bannerOpacity = math.min(1, self.bannerOpacity + dt * 3) else self.bannerOpacity = self.bannerOpacity - dt if self.bannerOpacity <= 0 then if self.bannerHolder then self.bannerHolder:RemoveBanner(self) end self:Kill() end end if self.bannerOpacity > 0 then self.bg:SetTint(1, 1, 1, self.bannerOpacity) local c = self.bannerColor self.bannerText:SetColor(c.r or c[1] or 1, c.g or c[2] or 1, c.b or c[3] or 1, self.bannerOpacity) local w, h = self:GetSize() local offset = self:GetOffset() local x, y = offset.x, offset.y local tX, tY = w / 2 * self.screenScale,(h / 2 - h * self.bannerIndex) * self.screenScale local p = 0.1 self:SetOffset(Lerp(x, tX, p), Lerp(y, tY, p)) end end end dycguis.Banner = DYC_Banner local DYC_BannerHolder = Class(DYC_Root, function(self, data) data = data or {} DYC_Root._ctor(self, data) self.banners = {} self.bannerInfos = {} self.bannerInterval = data.interval or 0.3 self.bannerShowTimer = 999 self.bannerSound = data.sound or "dontstarve/HUD/XP_bar_fill_unlock" self.maxBannerNum = data.max or 6 self:StartUpdating() end) function DYC_BannerHolder:PushMessage(text, duration, color, playSound) table.insert(self.bannerInfos, {text = text, duration = duration, color = color, playSound = playSound}) end function DYC_BannerHolder:ShowMessage(text, duration, color, playSound) local banner = self:AddChild(DYC_Banner({text = text, duration = duration, color = color})) self:AddBanner(banner) local player = DYCGetPlayer() if playSound and player and player.SoundEmitter and self.bannerSound then player.SoundEmitter:PlaySound(self.bannerSound) end end function DYC_BannerHolder:AddBanner(banner) banner.bannerHolder = self local banners = self.banners table.insert(banners, 1, banner) for i = 1, #banners do banners[i].bannerIndex = i end end function DYC_BannerHolder:RemoveBanner(banner) for k, v in pairs(self.banners) do if v == banner then table.remove(self.banners, k) break end end for k, v in pairs(self.banners) do v.bannerIndex = k end end function DYC_BannerHolder:OnUpdate(dt) dt = dt or 0 local banners = self.banners local infos = self.bannerInfos if dt > 0 and #banners > 0 then for i = 1, #banners do local banner = banners[i] if i > self.maxBannerNum then banner:SetShouldFadeOut() elseif banner.bannerTimer <= 0 then banner:SetShouldFadeOut() end end end if dt > 0 and #infos > 0 then self.bannerShowTimer = self.bannerShowTimer + dt if self.bannerShowTimer >= self.bannerInterval then self.bannerShowTimer = 0 local info = infos[1] table.remove(infos, 1) if #infos <= 0 then self.bannerShowTimer = 999 end self:ShowMessage(info.text, info.duration, info.color, info.playSound) end end end dycguis.BannerHolder = DYC_BannerHolder local DYC_MessageBox = Class(DYC_Window, function(self, data) DYC_Window._ctor(self) self.messageText = self.rootM:AddChild(DYC_Text({font = self.font, fontSize = data.fontSize or self.fontSize, color = RGBAColor(0.9, 0.9, 0.9, 1),})) self.strings = data.strings self.callback = data.callback local closeButton = self.rootTR:AddChild(DYC_ImageButton({width = 40, height = 40, normal = "button_checkbox1.tex" , focus = "button_checkbox1.tex" , disabled = "button_checkbox1.tex" , colornormal = RGBAColor(1, 1, 1, 1), colorfocus = RGBAColor(1, 0.2, 0.2, 0.7), colordisabled = RGBAColor(0.4, 0.4, 0.4, 1), cb = function() if self.callback then self.callback(self, false) end self:Kill() end,})) closeButton:SetPosition( - self.paddingX - closeButton.width / 2, - self.paddingY - closeButton.height / 2, 0) local okButton = self.rootB:AddChild(DYC_ImageButton({width = 100, height = 50, text = self.strings:GetString( "ok" ), cb = function() if self.callback then self.callback(self, true) end self:Kill() end,})) okButton:SetPosition(0, self.paddingY + okButton.height / 2, 0) if data.message then self:SetMessage(data.message) end if data.title then self:SetTitle(data.title, nil,(data.fontSize or self.fontSize) * 1.3) end end) function DYC_MessageBox:SetMessage(str) self.messageText:SetText(str) end function DYC_MessageBox.ShowMessage(str, title, root, strings, cb, fs, w, h, aw, ah, at) local mb = root:AddChild(DYC_MessageBox({message = str, title = title, callback = cb, strings = strings, fontSize = fs})) if at then mb.messageText:AnimateIn() end if w and h and aw and ah then mb:SetSize(aw, ah) mb:AnimateSize(w, h, 10) elseif w and h then mb:SetSize(w, h) end end dycguis.MessageBox = DYC_MessageBox local DYC_ObjectDetailWindow = Class(DYC_Window, function(self, data) DYC_Window._ctor(self) self:SetBottomLeftAlignment() self.bg:SetClickable(false) self:SetSize(400, 250) data = data or {} self.fontSize = data.fontSize or 25 self.opacity = data.opacity or 1 self.nameFont = data.nameFont self.hintFont = data.hintFont end) function DYC_ObjectDetailWindow:RefreshPage(data) self:ClearPages() data = data or {} local alpha = self.opacity self.bg:SetTint(1, 1, 1, alpha) local colorOther = RGBAColor(0.76, 0.76, 0.76):A(alpha) local colorDefault = RGBAColor():A(alpha) local colorEnc = RGBAColor(255 / 255, 0 / 255, 0 / 255):A(alpha) local colorDes = RGBAColor(170 / 255, 238 / 255, 255 / 255):A(alpha) local colorAction = RGBAColor(255 / 255, 245 / 255, 187 / 255):A(alpha) self.lineHeight = self.fontSize local maxWidth = math.min(self.lineHeight / 25 * 550, 900) self.paddingX = 35 self.paddingY = 35 self.lineSpacingY = 0 self.font = DEFAULTFONT local titleFont = not IsRail() and not IsDST() and dycguis.language and dycguis.language == "en" and self.nameFont or self.font local hintFont = not IsRail() and not IsDST() and dycguis.language and dycguis.language == "en" and self.hintFont or TALKINGFONT local titleScale = 1.3 local nameScale = 1.3 local calcWidth, calcHeight = 0, 0 local multiLines = false local NewLine = function(lh) self:NewLine(lh) end if data.action and #data.action > 0 then local actionText = self:AddContent(DYC_Text({font = hintFont, fontSize = self.fontSize * titleScale, text = data.action or "???" , color = data.actionColor or colorAction,})) end if data.prefix and #data.prefix > 0 then local prefixText = self:AddContent(DYC_Text({font = titleFont, fontSize = self.fontSize * titleScale, text = data.prefix or "???" , color = data.prefixColor or colorDefault,})) end if data.name and #data.name > 0 then local nameText = self:AddContent(DYC_Text({font = titleFont, fontSize = self.fontSize * nameScale, text = data.name or "???" , color = data.nameColor and data.nameColor:A(alpha) or colorDefault,})) end if data.suffix and #data.suffix > 0 then local suffixText = self:AddContent(DYC_Text({font = titleFont, fontSize = self.fontSize * titleScale, text = data.suffix or "???" , color = data.suffixColor or colorDefault,})) end calcWidth = math.max(calcWidth, self.currentLineX) calcHeight = calcHeight + self.lineHeight NewLine(0.4) calcHeight = calcHeight + self.lineHeight * 0.4 if data.action2 and #data.action2 > 0 then multiLines = true NewLine(1) local action2Text = self:AddContent(DYC_Text({font = hintFont, fontSize = self.fontSize, text = data.action2 or "???" , color = data.action2Color or colorAction,})) calcWidth = math.max(calcWidth, self.currentLineX) calcHeight = calcHeight + self.lineHeight end if data.rarity and #data.rarity > 0 then multiLines = true NewLine(1) local rarityText = self:AddContent(DYC_Text({font = self.font, fontSize = self.fontSize, text = data.rarity or "" , color = colorDefault})) calcWidth = math.max(calcWidth, self.currentLineX) calcHeight = calcHeight + self.lineHeight end if data.lines then for k, v in pairs(data.lines) do multiLines = true NewLine(1) local newText = self:AddContent(DYC_Text({font = self.font, fontSize = self.fontSize, text = v.text or "" , color = v.color and v.color:A(alpha) or colorOther})) calcWidth = math.max(calcWidth, self.currentLineX) calcHeight = calcHeight + self.lineHeight end end if data.encLines then for k, v in pairs(data.encLines) do if not v.isHidden and v.text and #v.text > 0 then multiLines = true NewLine(1) local newText = self:AddContent(DYC_Text({font = self.font, fontSize = self.fontSize, text = v.text, color = v.color and v.color:A(alpha) or colorEnc})) calcWidth = math.max(calcWidth, self.currentLineX) calcHeight = calcHeight + self.lineHeight end end end NewLine(2.5) local desText = nil if data.des and #data.des > 0 then multiLines = true desText = self:AddContent(DYC_Text({font = self.font, fontSize = self.fontSize, text = data.des or "" , color = data.desColor and data.desColor:A(alpha) or colorDes})) local desWidth = desText:GetWidth() local minWidth = 230 if desWidth > calcWidth then if desWidth >= minWidth and calcWidth < minWidth then calcWidth = minWidth elseif desWidth < minWidth and calcWidth < minWidth then calcWidth = desWidth end end end calcWidth = math.min(calcWidth, maxWidth) if not multiLines then calcHeight = calcHeight - self.lineHeight * 0.4 end local windowW = calcWidth + self.paddingX * 2 local windowH = calcHeight + self.paddingY * 2 if desText then local oldDesWidth = desText:GetWidth() desText:SetRegionSize(calcWidth, self.fontSize * 10) desText:SetPosition(windowW / 2, - calcHeight - self.paddingY - desText:GetHeight() / 2, 0) desText:SetHAlign(ANCHOR_LEFT) desText:SetVAlign(ANCHOR_TOP) desText:EnableWordWrap(true) local multiLineScale = dycguis.multiLineScale or 1 windowH = windowH + self.fontSize * multiLineScale * (math.floor((oldDesWidth - 0.0001) / desText:GetWidth()) + 1) end self:SetSize(windowW, windowH) end function DYC_ObjectDetailWindow:SetObjectDetail(data) self:RefreshPage(data) end function DYC_ObjectDetailWindow:OnUpdate(dt) DYC_ObjectDetailWindow._base.OnUpdate(self, dt) dt = dt or 0 end dycguis.ObjectDetailWindow = DYC_ObjectDetailWindow return dycguis 